/***************************************************************
Subject to the terms and conditions set forth below, Intel hereby 
grants you a nonexclusive, nontransferable license, under its 
patents and copyrights on the example source code sequences listed 
below,  to use, reproduce and distribute such example source code 
sequences, in object code format, solely as part of your computer 
program(s) and solely in order to allow your computer program(s) 
to implement the multimedia instruction extensions contained in 
such sequences solely with respect to the Intel instruction set 
architecture.  No other license, express, implied, statutory, by 
estoppel or otherwise, to any other intellectual property rights 
is granted herein.

THE EXAMPLE SOURCE CODE SEQUENCES LISTED BELOW ARE  PROVIDED "AS IS" 
WITH NO WARRANTIES, EXPRESS, IMPLIED, STATUTORY OR OTHERWISE, AND INTEL 
SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF MERCHANTABILITY,  
NONINFRINGEMENT OR FITNESS FOR ANY PARTICULAR PURPOSE.

Any use or distribution of  example source code sequences listed below 
must  fully comply with all then current laws of the United States 
including, without limitation, rules and regulations of the 
United States Office of Export Administration and other applicable 
U.S. governmental agencies.
 
IN NO EVENT WILL INTEL BE LIABLE FOR ANY DAMAGES OF ANY KIND, INCLUDING 
DIRECT OR INDIRECT DAMAGES, LOSS OF DATA, LOST PROFITS, COST OF COVER OR 
SPECIAL, INCIDENTAL, CONSEQUENTIAL, DAMAGES ARISING FROM THE USE OF THE 
EXAMPLE SOURCE CODE SEQUENCES LISTED BELOW, HOWEVER CAUSED AND ON ANY 
THEORY OF LIABILITY.  THIS LIMITATION WILL APPLY EVEN IF INTEL OR ANY 
AUTHORIZED AGENT OF INTEL HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH 
DAMAGE.

Copyright c 1996 Intel Corporation 
***********************************************************************/
/**********************************************************************/
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys\stat.h>

/* specific headers and definitions for this program */
#include "pmapp.h"
#include "genericr.h"

char	ExecFile [40];

void upper(char *string){
	int	ln, i;
	ln = strlen(string);
	for (i=0; i<ln; i++)
	{
		string[i] = (char)toupper(string[i]);
	}
}

void	ParseCommandLine(LPSTR lpCmdLine){
	LPSTR	tempcmd, tmp1;
	char	Switch;
	int	i;

	tempcmd= lpCmdLine; /* save command line pointer */
 
//sprintf(lpCmdLine, " ");
//sprintf(szLineout, "/start_acc /t0cPl=30 /T1CPL=0 /t0=3 /t1=20 /batch /interval=1000 /samples=5 /msg=batch_acc /file=aaa.txt");
//tempcmd= szLineout; /* save command line pointer */

//sprintf (tempcmd, "/t0=7 /T1=33 /t0cPl=3 /T1CPL=0  /GUI /StaRt ");

//sprintf (tempcmd, "/t0=1 /T1=12 /t0cPl=30 /T1CPL=0 /St4aRt /bat4ch /p55c");

  /* get command line parameter: op-code index */

if (strlen(tempcmd) > 0)
  {
		upper(tempcmd);
		while (*tempcmd != '\0')
		{
			if (!strncmp(tempcmd, "/T0=", 4))
						Switch = T0EVENT;
			else	if (!strncmp(tempcmd, "/T1=", 4))
						Switch = T1EVENT;
			else	if (!strncmp(tempcmd, "/T0CPL=", 7))
						Switch = T0CPL;
			else	if (!strncmp(tempcmd, "/T1CPL=", 7))
						Switch = T1CPL;
	//		else	if (!strncmp(tempcmd, "/T0MASK=", 8))
	//					Switch = T0MASK;
	//		else	if (!strncmp(tempcmd, "/T1MASK=", 8))
	//					Switch = T1MASK;
			else	if (!strncmp(tempcmd, "/STOP", 5))
						Switch = STOP;
			else	if (!strncmp(tempcmd, "/FILE=", 6))
						Switch = LOGFILE;
			else	if (!strncmp(tempcmd, "/MSG=", 5))
						Switch = LOGMSG;
			else	if (!strncmp(tempcmd, "/P55C", 5))
						Switch = P55C;
			else	if (!strncmp(tempcmd, "/START", 6))
						Switch = START;
			else	if (!strncmp(tempcmd, "/ACC_START", 10))
						Switch = START_ACC;
			else	if (!strncmp(tempcmd, "/DELAY_START", 12))
						Switch = START_DELAY;
			else	if (!strncmp(tempcmd, "/BATCH", 6))
						Switch = BATCH;
			else	if (!strncmp(tempcmd, "/INTERVAL=", 10))
						Switch = INTERVAL;
			else	if (!strncmp(tempcmd, "/DELAY=",  7))
						Switch = DELAY;
			else	if (!strncmp(tempcmd, "/UNLOAD",  8))
						Switch = UNLOAD_VXD_ON_EXIT;
			else	if (!strncmp(tempcmd, "/SAMPLES=",  9))
						Switch = SAMPLES;

			switch (Switch){
				case	T0EVENT:
					tempcmd =tempcmd+4;
					T0ReqEvent = (BYTE)atoi(tempcmd);
				break;
				case	T1EVENT:
					tempcmd =tempcmd+4;
					T1ReqEvent = (BYTE)atoi(tempcmd);
				break;
				case	T0CPL:
					tempcmd =tempcmd+7;
					ReqCnt0Ring = (BYTE)atoi(tempcmd);
				break;
				case	T1CPL:
					tempcmd =tempcmd+7;
					ReqCnt1Ring = (BYTE)atoi(tempcmd);
				break;
				case	START:
					tempcmd =tempcmd+5;
					StartReq = TRUE;
				break;
				case	STOP:
					tempcmd =tempcmd+5;
					StopReq = TRUE;
				break;
				case	LOGFILE:
					tempcmd =tempcmd+6;
					tmp1 = tempcmd;
					i=1;
					while ((*tmp1 != '/') && (*tmp1 != '\0') && (*tmp1 != ' ')){
						i++;
						tmp1++;
					}
					strncpy(LogFileName, tempcmd, i-1);
					LogFileName[i-1]=0;
					FileLogReq	= TRUE;
				break;
				case	LOGMSG:
					tempcmd =tempcmd+5;
					tmp1 = tempcmd;
					i=1;
					while ((*tmp1 != '/') && (*tmp1 != '\0')){
						i++;
						tmp1++;
					}
					strncpy(LogMessage, tempcmd, i-1);
			   LogMessage[i-1]=0;
				break;

				case	EXEC_FILE:
					tempcmd =tempcmd+11;
					tmp1 = tempcmd;
					i=1;
					while ((*tmp1 != '/') && (*tmp1 != '\0')){
						i++;
						tmp1++;
					}
					strncpy(ExecFile, tempcmd, i-1);
					ExecFile[i-1]=0;
				break;

				case	BATCH:
					tempcmd =tempcmd+6;
					BatchMode = TRUE;
					unload_vxd_on_exit = FALSE;
				break;
/*				case	NO_GUI:
					tempcmd =tempcmd+7;
					InterActiveMode = FALSE;
				break;*/

				case	START_ACC:
					tempcmd =tempcmd+10;
					AccumulateMode = TRUE;
				break;

				case	P55C:
					tempcmd =tempcmd+5;
					P55C_mode = TRUE;
				break;

				case	UNLOAD_VXD_ON_EXIT:
					tempcmd =tempcmd+8;
					unload_vxd_on_exit = TRUE;
				break;

				case	INTERVAL:
					tempcmd =tempcmd+10;
					Interval = atoi(tempcmd);
				break;

				case	DELAY:
					tempcmd =tempcmd+8;
					Delay = atoi(tempcmd);
				break;

				case	START_DELAY:
					tempcmd =tempcmd+13;
					StartDelayMode = TRUE;
				break;

				case	SAMPLES:
					tempcmd =tempcmd+9;
					BufferSize = atoi(tempcmd);
		PutMsg("SAMPLES");
				break;

				default:
					tempcmd++;
		PutMsg("Unknown");
				break;

			}while ((*tempcmd != '/') && (*tempcmd != '\0'))
						tempcmd++;
		}
  }// cmdline>0
}
