#define	Pmon32_OK	0
#define	Pmon32_UnableToLoadVxD		1
#define	Pmon32_VxDIsNotResponding	2
#define	Pmon32_InvalidEvent0Index	3
#define	Pmon32_InvalidEvent1Index	4

#define	Pmon32_Counters_Running		TRUE
#define	Pmon32_Counters_Stopped		FALSE


// used in start routine to identify rings
#define	Ring0		0
#define	Ring0123    30
#define	Ring123     3


// more error later

// The dll name will be: PMON32.DLL
#include <pshpack1.h>

struct	Pmon32StartCmd{
	BYTE	Event0;
	BYTE	Event1;
	BYTE	Event0Ring;
	BYTE	Event1Ring;

	BYTE	Event0Mask;
	BYTE	Event1Mask;
	BYTE	Flg1;
	BYTE	Flg2;

	BOOL	unload_vxd_on_exit;
	BOOL	Flg3;
	BOOL	Flg4;
	BOOL	Flg5;

	DWORD	Res1;
	DWORD	Res2;
	DWORD	Res3;
};

struct	Pmon32Reply{
	DWORD	T0_l;
	DWORD	T0_h;
	DWORD	T1_l;
	DWORD	T1_h;
	DWORD	TSC_l;
	DWORD	TSC_h;
	DWORD	ElapsedTime_l;
	DWORD	ElapsedTime_h;
	DWORD	TSCLast_l;
	DWORD	TSCLast_h;
	BYTE	Event0;
	BYTE	Event1;
	BYTE	Event0Ring;
	BYTE	Event1Ring;
	BYTE	Event0Mask;
	BYTE	Event1Mask;
	BYTE	pad1  ;
	BYTE	pad2  ;
	DWORD	status;
	DWORD	res1;
	DWORD	res2;
	DWORD	res3;
	DWORD	res4;
	DWORD	res5;
	DWORD	res6;
};

struct	Pmon32Version{
	char	VxDVersion[32];
	char	DLLVersion[32];
	int		VxDMajor;
	int		VxDMinor;
	int		DLLMajor;
	int		DLLMinor;
	char	res2[16];
};

#include <poppack.h>

DWORD	(FAR *Pmon32Init)	(struct Pmon32Version *ver);
DWORD	(FAR *Pmon32Close)  (void);

DWORD	(FAR *Pmon32Status) (struct	Pmon32Reply	*Reply);
BOOL	(FAR *Pmon32AreCountersRunning) ();

DWORD	(FAR *Pmon32Start)	(BYTE Event0, BYTE Event0Ring, BYTE	Event1, BYTE Event1Ring);
DWORD	(FAR *Pmon32StopAndReadCounters)	(struct	Pmon32Reply	*Reply);

DWORD	(FAR *Pmon32ReadCounters) (struct	Pmon32Reply	*Reply);
DWORD	(FAR *Pmon32ReadTSC)		(struct	Pmon32Reply	*Reply);

DWORD	(FAR *Pmon32EnableRDPMCRing3)	(void);
DWORD	(FAR *Pmon32DisableRDPMCRing3)	(void);

char	*	(FAR *Pmon32Event0ToStr)(BYTE	index);
char	*	(FAR *Pmon32Event1ToStr)(BYTE	index);


// new
DWORD	(FAR  *Pmon32StartEx)	(struct	Pmon32StartCmd	*Cmd);
DWORD	(FAR  *Pmon32StartDirect)(DWORD E0, DWORD E1, char *str0, char *str1);
DWORD	(FAR  *Pmon32InstallEvent) (BYTE Cnt, BYTE Index, BYTE	Encoding, BYTE Mask, char *str);
DWORD	(FAR  *Pmon32InitEx) (struct	Pmon32StartCmd	*Cmd, struct Pmon32Version *ver);

// undocumented/not tested
void	(FAR  *ReadMSR) (DWORD Reg, DWORD *EDX, DWORD *EAX);
void	(FAR  *ReadModifWriteMSR) (DWORD Reg, DWORD Operation, DWORD *EDX, DWORD *EAX);

