/***************************************************************
Subject to the terms and conditions set forth below, Intel hereby 
grants you a nonexclusive, nontransferable license, under its 
patents and copyrights on the example source code sequences listed 
below,  to use, reproduce and distribute such example source code 
sequences, in object code format, solely as part of your computer 
program(s) and solely in order to allow your computer program(s) 
to implement the multimedia instruction extensions contained in 
such sequences solely with respect to the Intel instruction set 
architecture.  No other license, express, implied, statutory, by 
estoppel or otherwise, to any other intellectual property rights 
is granted herein.

THE EXAMPLE SOURCE CODE SEQUENCES LISTED BELOW ARE  PROVIDED "AS IS" 
WITH NO WARRANTIES, EXPRESS, IMPLIED, STATUTORY OR OTHERWISE, AND INTEL 
SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF MERCHANTABILITY,  
NONINFRINGEMENT OR FITNESS FOR ANY PARTICULAR PURPOSE.

Any use or distribution of  example source code sequences listed below 
must  fully comply with all then current laws of the United States 
including, without limitation, rules and regulations of the 
United States Office of Export Administration and other applicable 
U.S. governmental agencies.
 
IN NO EVENT WILL INTEL BE LIABLE FOR ANY DAMAGES OF ANY KIND, INCLUDING 
DIRECT OR INDIRECT DAMAGES, LOSS OF DATA, LOST PROFITS, COST OF COVER OR 
SPECIAL, INCIDENTAL, CONSEQUENTIAL, DAMAGES ARISING FROM THE USE OF THE 
EXAMPLE SOURCE CODE SEQUENCES LISTED BELOW, HOWEVER CAUSED AND ON ANY 
THEORY OF LIABILITY.  THIS LIMITATION WILL APPLY EVEN IF INTEL OR ANY 
AUTHORIZED AGENT OF INTEL HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH 
DAMAGE.

Copyright c 1996 Intel Corporation 
***********************************************************************/
/**********************************************************************/
/* system header files */
#include <windows.h>
#include <stdio.h>
#include <time.h>
#include <dos.h>
#include <direct.h>
#include <io.h>
#include <stdlib.h>
#include <sys\stat.h>

/* specific headers and definitions for this program */
#include "pmapp.h"
#include "genericr.h"

#include "dll_if.h"

char	IniFile [100];
char Initialization_Header[] = {"Initialization Values"};

char LastEvent0Index[]	= {"Event 0 Last Selection"};
char LastEvent1Index[]	= {"Event 1 Last Selection"};

char LastEvent0Ring[]	= {"Event 0 Last Ring Selection"};
char LastEvent1Ring[]	= {"Event 1 Last Ring Selection"};

char LastEvent0Mask[]	= {"Event 0 Last Mask Selection"};
char LastEvent1Mask[]	= {"Event 1 Last Mask Selection"};

char LastInterval[]		= {"Interval [in ms]"};
char LastBufferSize[]	= {"Buffer Size"};
char LastDelay[]		= {"Delay [in ms]"};
char LastAutoStopTime[]	= {"Auto Stop Time [in sec]"};

//====================================================
void	HandleINIFile(void){

struct	stat	statbuf;
// what's the current setting of the counters
	getcwd(IniFile, 64);
	strcat(IniFile,"\\");
	strcat(IniFile, PmonIniFileName);

	if (stat(IniFile, &statbuf)){
		sprintf(szLineout, "INI File ( %s ) NOT Found. Creating...Done", IniFile);
		PutMsg (szLineout);
		creat(IniFile, S_IREAD | S_IWRITE);
	}
	else{
		sprintf(szLineout, "INI File  ( %s ) Found", IniFile);
		PutMsg (szLineout);
	}

	GetPrivateProfileString(Initialization_Header, "Read PMC From Level 3", "",
										szLineout, 5, IniFile);
	if (!strcmp(szLineout, "")){
			WritePrivateProfileString(Initialization_Header, "Read PMC From Level 3",
							"ON", IniFile);
			PutMsg ("Default: Usage of RDPMC From Level 3 is Enabled");
			Pmon32EnableRDPMCRing3 ();
	}
	else
	{
		upper(szLineout);
		if (!strcmp(szLineout, "OFF")){
			Pmon32DisableRDPMCRing3 ();
			PutMsg ("Usage of RDPMC From Level 3 is Disabled by INI file");
		}
		if (!strcmp(szLineout, "ON")){
			if ( ( (CPUID_FeatureFlags&0x800000)==0x800000) ||
				 (Which_CPU == PentiumPro)					)
			{
				Pmon32EnableRDPMCRing3 ();
				PutMsg ("Read PMC From Level 3 is Enabled by INI file");
			}
			else
				PutMsg ("Request PMC From Level 3 is rejected. No CPU support!");
		}
	}

//Interval
	GetPrivateProfileString(Initialization_Header, LastInterval, "",
										szLineout, 10, IniFile);
	if (!strcmp(szLineout, ""))
		WritePrivateProfileString(Initialization_Header, LastInterval,
							"100", IniFile);
	GetPrivateProfileString(Initialization_Header, LastInterval, "",
										szLineout, 10, IniFile);
	Interval = atoi(szLineout);

//Delay
	GetPrivateProfileString(Initialization_Header, LastDelay, "",
										szLineout, 10, IniFile);
	if (!strcmp(szLineout, ""))
		WritePrivateProfileString(Initialization_Header, LastDelay,
							"0", IniFile);
	GetPrivateProfileString(Initialization_Header, LastDelay, "",
										szLineout, 10, IniFile);
	DelayAfterStart = atoi(szLineout);

//Samples
	GetPrivateProfileString(Initialization_Header, LastBufferSize, "",
										szLineout, 10, IniFile);
	if (!strcmp(szLineout, ""))
		WritePrivateProfileString(Initialization_Header, LastBufferSize,
							"5000", IniFile);
	GetPrivateProfileString(Initialization_Header, LastBufferSize, "",
										szLineout, 10, IniFile);
	BufferSize = atoi(szLineout);

//Auto Stop
	GetPrivateProfileString(Initialization_Header, LastAutoStopTime, "",
										szLineout, 10, IniFile);
	if (!strcmp(szLineout, ""))
		WritePrivateProfileString(Initialization_Header, LastAutoStopTime,
							"1000", IniFile);
	GetPrivateProfileString(Initialization_Header, LastAutoStopTime, "",
										szLineout, 10, IniFile);
	Auto_Stop_Time = atoi(szLineout);
	
	
	
	GetPrivateProfileString(Initialization_Header, LastEvent0Index, "",
										szLineout, 5, IniFile);
	if (!strcmp(szLineout, ""))
		WritePrivateProfileString(Initialization_Header, LastEvent0Index,
							"0", IniFile);
	GetPrivateProfileString(Initialization_Header, LastEvent0Index, "",
										szLineout, 5, IniFile);
	LastEvent0Selected = atoi(szLineout);
	
	GetPrivateProfileString(Initialization_Header, LastEvent1Index, "",
										szLineout, 5, IniFile);
	if (!strcmp(szLineout, ""))
		WritePrivateProfileString(Initialization_Header, LastEvent1Index,
							"0", IniFile);
	GetPrivateProfileString(Initialization_Header, LastEvent1Index, "",
										szLineout, 5, IniFile);
	LastEvent1Selected = atoi(szLineout);

	SelectEventsInComboBox(LastEvent0Selected, LastEvent1Selected);

	
// Ring	
	GetPrivateProfileString(Initialization_Header, LastEvent0Ring, "",
										szLineout, 5, IniFile);
	if (!strcmp(szLineout, ""))
		WritePrivateProfileString(Initialization_Header, LastEvent0Ring,
							"0", IniFile);
	GetPrivateProfileString(Initialization_Header, LastEvent0Ring, "",
										szLineout, 5, IniFile);
	LastRingForCnt0Selected = atoi(szLineout);
	
	GetPrivateProfileString(Initialization_Header, LastEvent1Ring, "",
										szLineout, 5, IniFile);
	if (!strcmp(szLineout, ""))
		WritePrivateProfileString(Initialization_Header, LastEvent1Ring,
							"0", IniFile);
	GetPrivateProfileString(Initialization_Header, LastEvent1Ring, "",
										szLineout, 5, IniFile);
	LastRingForCnt1Selected = atoi(szLineout);

// Mask	
	GetPrivateProfileString(Initialization_Header, LastEvent0Mask, "",
										szLineout, 5, IniFile);
	if (!strcmp(szLineout, ""))
		WritePrivateProfileString(Initialization_Header, LastEvent0Mask,
							"0", IniFile);
	GetPrivateProfileString(Initialization_Header, LastEvent0Mask, "",
										szLineout, 5, IniFile);
	sscanf (szLineout, "0x%2X", &LastMaskForCnt0Selected);


	GetPrivateProfileString(Initialization_Header, LastEvent1Mask, "",
										szLineout, 5, IniFile);
	if (!strcmp(szLineout, ""))
		WritePrivateProfileString(Initialization_Header, LastEvent1Mask,
							"0", IniFile);
	GetPrivateProfileString(Initialization_Header, LastEvent1Mask, "",
										szLineout, 5, IniFile);
	sscanf (szLineout, "0x%2X", &LastMaskForCnt1Selected);


	

	sprintf (szLineout, "CPU ID: Family=%u, Model=%u, Step=%u, Feature=%8lX",
					((CPUID_FamilyModelStepping>>8)&0xF),	
					((CPUID_FamilyModelStepping>>4)&0xF),	
					((CPUID_FamilyModelStepping>>0)&0xF),	
					CPUID_FeatureFlags
					);
	if ( (CPUID_FeatureFlags&0x800000)==0x800000)
		strcat(szLineout, " - MMX technology");

	PutMsg (szLineout);
}

//==================================================
void	UpdateDialogWithLastSelection(void){

	Pmon32Status(&Reply);
	if (Reply.status == Pmon32_Counters_Running){
		LastEvent0Selected = Reply.Event0;
		LastEvent1Selected = Reply.Event1;
		
		LastRingForCnt0Selected = Reply.Event0Ring;
		LastRingForCnt1Selected = Reply.Event1Ring;

		LastMaskForCnt0Selected = Reply.Event0Mask;
		LastMaskForCnt1Selected = Reply.Event1Mask;
	}


	if (LastRingForCnt0Selected == 30){
		CheckDlgButton (MainDlg, IDC_CNT0_L012, 1);
		CheckDlgButton (MainDlg, IDC_CNT0_L3, 1);
	}
	if  (LastRingForCnt0Selected == 3){
		CheckDlgButton (MainDlg, IDC_CNT0_L012, 0);
		CheckDlgButton (MainDlg, IDC_CNT0_L3, 1);
	}
	if  (LastRingForCnt0Selected == 0){
		CheckDlgButton (MainDlg, IDC_CNT0_L012, 1);
		CheckDlgButton (MainDlg, IDC_CNT0_L3, 0);
	}

	if (LastRingForCnt1Selected == 30){
		CheckDlgButton (MainDlg, IDC_CNT1_L012, 1);
		CheckDlgButton (MainDlg, IDC_CNT1_L3, 1);
	}
	if  (LastRingForCnt1Selected == 3){
		CheckDlgButton (MainDlg, IDC_CNT1_L012, 0);
		CheckDlgButton (MainDlg, IDC_CNT1_L3, 1);
	}
	if  (LastRingForCnt1Selected == 0){
		CheckDlgButton (MainDlg, IDC_CNT1_L012, 1);
		CheckDlgButton (MainDlg, IDC_CNT1_L3, 0);
	}

	SelectEventsInComboBox(LastEvent0Selected, LastEvent1Selected);

	SendMessage (Event0MaskWnd, CB_SETCURSEL, LastMaskForCnt0Selected, 0);
	SendMessage (Event1MaskWnd, CB_SETCURSEL, LastMaskForCnt1Selected, 0);
	
	SendMessage (T0IndexWnd, CB_SETCURSEL, (WPARAM)LastEvent0Selected, 0);
	SendMessage (T1IndexWnd, CB_SETCURSEL, (WPARAM)LastEvent1Selected, 0);
}

//==================================================
void SaveToIniFile(void){

	sprintf (szLineout, "%u", LastEvent0Selected);
	WritePrivateProfileString(Initialization_Header, LastEvent0Index,
							szLineout, IniFile);
	sprintf (szLineout, "%u", LastEvent1Selected);
	WritePrivateProfileString(Initialization_Header, LastEvent1Index,
							szLineout, IniFile);

	sprintf (szLineout, "%u", LastRingForCnt0Selected);
	WritePrivateProfileString(Initialization_Header, LastEvent0Ring,
							szLineout, IniFile);
	sprintf (szLineout, "%u", LastRingForCnt1Selected);
	WritePrivateProfileString(Initialization_Header, LastEvent1Ring,
							szLineout, IniFile);

	sprintf (szLineout, "0x%02X", LastMaskForCnt0Selected);
	WritePrivateProfileString(Initialization_Header, LastEvent0Mask,
							szLineout, IniFile);

	sprintf (szLineout, "0x%02X", LastMaskForCnt1Selected);
	WritePrivateProfileString(Initialization_Header, LastEvent1Mask,
							szLineout, IniFile);

	sprintf (szLineout, "%u", Interval);
	WritePrivateProfileString(Initialization_Header, LastInterval,
							szLineout, IniFile);
	sprintf (szLineout, "%u", DelayAfterStart);
	WritePrivateProfileString(Initialization_Header, LastDelay,
							szLineout, IniFile);
	sprintf (szLineout, "%u", BufferSize);
	WritePrivateProfileString(Initialization_Header, LastBufferSize,
							szLineout, IniFile);
	sprintf (szLineout, "%u", Auto_Stop_Time);
	WritePrivateProfileString(Initialization_Header, LastAutoStopTime,
							szLineout, IniFile);

}