/***************************************************************
Subject to the terms and conditions set forth below, Intel hereby 
grants you a nonexclusive, nontransferable license, under its 
patents and copyrights on the example source code sequences listed 
below,  to use, reproduce and distribute such example source code 
sequences, in object code format, solely as part of your computer 
program(s) and solely in order to allow your computer program(s) 
to implement the multimedia instruction extensions contained in 
such sequences solely with respect to the Intel instruction set 
architecture.  No other license, express, implied, statutory, by 
estoppel or otherwise, to any other intellectual property rights 
is granted herein.

THE EXAMPLE SOURCE CODE SEQUENCES LISTED BELOW ARE  PROVIDED "AS IS" 
WITH NO WARRANTIES, EXPRESS, IMPLIED, STATUTORY OR OTHERWISE, AND INTEL 
SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF MERCHANTABILITY,  
NONINFRINGEMENT OR FITNESS FOR ANY PARTICULAR PURPOSE.

Any use or distribution of  example source code sequences listed below 
must  fully comply with all then current laws of the United States 
including, without limitation, rules and regulations of the 
United States Office of Export Administration and other applicable 
U.S. governmental agencies.
 
IN NO EVENT WILL INTEL BE LIABLE FOR ANY DAMAGES OF ANY KIND, INCLUDING 
DIRECT OR INDIRECT DAMAGES, LOSS OF DATA, LOST PROFITS, COST OF COVER OR 
SPECIAL, INCIDENTAL, CONSEQUENTIAL, DAMAGES ARISING FROM THE USE OF THE 
EXAMPLE SOURCE CODE SEQUENCES LISTED BELOW, HOWEVER CAUSED AND ON ANY 
THEORY OF LIABILITY.  THIS LIMITATION WILL APPLY EVEN IF INTEL OR ANY 
AUTHORIZED AGENT OF INTEL HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH 
DAMAGE.

Copyright c 1996 Intel Corporation 
***********************************************************************/
/**********************************************************************/
            
/* system header files */
#include <windows.h>
#include <stdio.h>
#include <time.h>
#include <dos.h>
#include <direct.h>
#include <io.h>
#include <stdlib.h>
#include <sys\stat.h>

/* specific headers and definitions for this program */
#include "pmapp.h"
#include "genericr.h"

#include "dll_if.h"

void	InstallEventsAtApplication(BYTE Cnt, BYTE Index, BYTE	Encoding, 
								   BYTE Mask, char *str);
void	ReadIniFile_InstallIt(BYTE cnt, int Entries, char	* Header);
int HowManyNewEventToInstall (char * Header);

char	PentiumEvent0Msg []=	{"Pentium Additional Events - Counter 0"};
char	PentiumEvent1Msg []=	{"Pentium Additional Events - Counter 1"};
char	PentiumProEventMsg []=	{"Pentium Pro Additional Events"};

char	EventIniFile [50];

// ==================================
void	InstallEvents(void){

struct	stat	statbuf;
int	NewEvents;
FILE *EFile;


	// what's the current setting of the counters
	getcwd(EventIniFile, 64);
	strcat(EventIniFile,"\\");
	strcat(EventIniFile, "Events.ini");

	if (stat(EventIniFile, &statbuf)){
		sprintf(szLineout, "INI File ( %s ) NOT Found. Creating...Done", EventIniFile);
		PutMsg (szLineout);
		
		EFile = fopen(EventIniFile, "a+");
		fprintf(EFile,  "_\t\t\t   Help for adding an event\n"
						"_\t\t\t--------------------------------\n\n"
						"_\t\t\tTo add an event you should:\n\n"
						"*\tPut it in the right section, PPro or PP\n"
						"*\tEach event includes 4 lines:\n"
						"-\t\t\tE_str_n= The new event string\n"
						"-\t\t\tE_enc_n= the encoding in hex, example: 0x55\n"
						"-\t\t\tE_msk_n= The mask in hex, example 0xff\n"
						"-\t\t\tE_idx_n= The index, decimal, where to insert the event in the data base[0-119]\n"
						"_\t\t\t\tThe n, in the above strings, represents consecutive number [1-120]\n\n");
		fprintf(EFile,  "*\tUpdate the -Number Of New Events- to the number of events you add[1-120]\n");

		fprintf(EFile,  "\n\nUse the following examples to add your events.");
		
		fclose(EFile);
//		creat(EventIniFile, S_IREAD | S_IWRITE);
		WritePrivateProfileString(PentiumEvent0Msg,		"Number Of New Events",	"0", EventIniFile);
		WritePrivateProfileString(PentiumEvent1Msg,		"Number Of New Events",	"0", EventIniFile);
		WritePrivateProfileString(PentiumProEventMsg,	"Number Of New Events",	"0", EventIniFile);

		WritePrivateProfileString(PentiumEvent0Msg, "E_str_1", "Put a string here", EventIniFile);
		WritePrivateProfileString(PentiumEvent0Msg, "E_enc_1", "0x00", EventIniFile);
		WritePrivateProfileString(PentiumEvent0Msg, "E_msk_1", "0x00", EventIniFile);
		WritePrivateProfileString(PentiumEvent0Msg, "E_idx_1", "100", EventIniFile);

		WritePrivateProfileString(PentiumEvent1Msg, "E_str_1", "Put a string here", EventIniFile);
		WritePrivateProfileString(PentiumEvent1Msg, "E_enc_1", "0x00", EventIniFile);
		WritePrivateProfileString(PentiumEvent1Msg, "E_msk_1", "0x00", EventIniFile);
		WritePrivateProfileString(PentiumEvent1Msg, "E_idx_1", "100", EventIniFile);

		WritePrivateProfileString(PentiumProEventMsg, "E_str_1", "A string", EventIniFile);
		WritePrivateProfileString(PentiumProEventMsg, "E_enc_1", "0x00", EventIniFile);
		WritePrivateProfileString(PentiumProEventMsg, "E_msk_1", "0x00", EventIniFile);
		WritePrivateProfileString(PentiumProEventMsg, "E_idx_1", "100", EventIniFile);

	}
	else{
		sprintf(szLineout, "Event INI File Name= %s", EventIniFile);
		PutMsg (szLineout);
		if (Which_CPU == Pentium){
			NewEvents = HowManyNewEventToInstall (PentiumEvent0Msg);
			if (NewEvents>0)
				ReadIniFile_InstallIt(0, NewEvents, PentiumEvent0Msg);
			NewEvents = HowManyNewEventToInstall (PentiumEvent1Msg);
			if (NewEvents>0)
				ReadIniFile_InstallIt(1, NewEvents, PentiumEvent1Msg);
		}
		if (Which_CPU == PentiumPro){
			NewEvents = HowManyNewEventToInstall (PentiumProEventMsg);
			if (NewEvents>0)
				ReadIniFile_InstallIt(0, NewEvents, PentiumProEventMsg);
		}
		sprintf(szLineout, "Found %u events in %s file", NewEvents, EventIniFile);
	}
}

// =======================================================
void	ReadIniFile_InstallIt(BYTE cnt, int Entries, char	* Header){
char	Eventstr [54];
char	EventEncoding [25];
char	EventMask [25];
char	EventIndex[25];

int		Index, len, j, i;
BYTE	Mask, Encoding;
char	EventString [54];

	for (i=1; i<(Entries+1); i++){
		sprintf (Eventstr,		"E_str_%u", i);
		sprintf (EventEncoding, "E_enc_%u", i);
		sprintf (EventMask,		"E_msk_%u", i);
		sprintf (EventIndex,	"E_idx_%u", i);

		GetPrivateProfileString(Header, Eventstr , "",
											szLineout, 52, EventIniFile);

		if (strcmp(szLineout, "")){
			len = strlen(szLineout);
			if (len<52)
				for (j=len ; j<52;j++)
						strcat(&szLineout[j], " ");
			strcpy (EventString, szLineout);
		}
		else
			break;
		EventString[52] = 0;

		GetPrivateProfileString(Header, EventMask , "",
											szLineout, 5, EventIniFile);
		if (strcmp(szLineout, ""))
			sscanf (szLineout, "0x%2x", &Mask);
		else
			Mask = 0;

		GetPrivateProfileString(Header, EventIndex , "",
											szLineout, 5, EventIniFile);
		if (!strcmp(szLineout, ""))	
			break;

		Index = atoi (szLineout);

		GetPrivateProfileString(Header, EventEncoding , "",
											szLineout, 5, EventIniFile);
		if (!strcmp(szLineout, ""))	
			break;

		sscanf (szLineout, "0x%2x", &Encoding);

/*
		sprintf(szLineout, "Event = %s, Len=%u", EventString, strlen(EventString));
		PutMsg (szLineout);

		sprintf(szLineout, "Encoding = %02X, Mask = %02X, Index = %02X", 
						Encoding, Mask, Index);
		PutMsg (szLineout);
*/

		Pmon32InstallEvent(cnt, (BYTE)Index, Encoding, Mask, EventString); 
		InstallEventsAtApplication(cnt,  (BYTE)Index, Encoding, Mask, EventString);
	}
}


int HowManyNewEventToInstall (char * Header){

	GetPrivateProfileString(Header, "Number Of New Events", "",
										szLineout, 5, EventIniFile);
	if (!strcmp(szLineout, ""))
		WritePrivateProfileString(Header, "Number Of New Events",	"0", EventIniFile);

	GetPrivateProfileString(Header, "Number Of New Events", "",
										szLineout, 5, EventIniFile);
	return (atoi(szLineout));

}

void	InstallEventsAtApplication(BYTE Cnt, BYTE Index, BYTE	Encoding, 
								   BYTE Mask, char *str){

	Events[Index].encoding = Encoding;
	if (Which_CPU == Pentium){
		if (Cnt == 0){
			Events0p55C[Index].encoding = Encoding;
			strcpy(Events0p55C[Index].str, str);
		}
		else{
			Events1p55C[Index].encoding = Encoding;
			strcpy(Events1p55C[Index].str, str);
		}
	}

	if (Which_CPU == PentiumPro){
		PentiumPro_events[Index].encoding = Encoding;
		PentiumPro_events[Index].umask = Mask;
		strcpy(PentiumPro_events[Index].str, str);
	}
}
