/***************************************************************
Subject to the terms and conditions set forth below, Intel hereby 
grants you a nonexclusive, nontransferable license, under its 
patents and copyrights on the example source code sequences listed 
below,  to use, reproduce and distribute such example source code 
sequences, in object code format, solely as part of your computer 
program(s) and solely in order to allow your computer program(s) 
to implement the multimedia instruction extensions contained in 
such sequences solely with respect to the Intel instruction set 
architecture.  No other license, express, implied, statutory, by 
estoppel or otherwise, to any other intellectual property rights 
is granted herein.

THE EXAMPLE SOURCE CODE SEQUENCES LISTED BELOW ARE  PROVIDED "AS IS" 
WITH NO WARRANTIES, EXPRESS, IMPLIED, STATUTORY OR OTHERWISE, AND INTEL 
SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF MERCHANTABILITY,  
NONINFRINGEMENT OR FITNESS FOR ANY PARTICULAR PURPOSE.

Any use or distribution of  example source code sequences listed below 
must  fully comply with all then current laws of the United States 
including, without limitation, rules and regulations of the 
United States Office of Export Administration and other applicable 
U.S. governmental agencies.
 
IN NO EVENT WILL INTEL BE LIABLE FOR ANY DAMAGES OF ANY KIND, INCLUDING 
DIRECT OR INDIRECT DAMAGES, LOSS OF DATA, LOST PROFITS, COST OF COVER OR 
SPECIAL, INCIDENTAL, CONSEQUENTIAL, DAMAGES ARISING FROM THE USE OF THE 
EXAMPLE SOURCE CODE SEQUENCES LISTED BELOW, HOWEVER CAUSED AND ON ANY 
THEORY OF LIABILITY.  THIS LIMITATION WILL APPLY EVEN IF INTEL OR ANY 
AUTHORIZED AGENT OF INTEL HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH 
DAMAGE.

Copyright c 1996 Intel Corporation 
***********************************************************************/
/**********************************************************************/

/* system header files */
#include <windows.h>
#include <stdio.h>
#include <time.h>
#include <dos.h>
//#include <dir.h>
#include <io.h>
#include <stdlib.h>
#include <sys\stat.h>

/* specific headers and definitions for this program */
#include "pmapp.h"
#include "genericr.h"

#include "dll_if.h"


void	WriteCounterStopResultsToLogFile(){
	char Ring0Str[20], Ring1Str[20];
	time_t time1;
	char	LogFileNameFull [64];

	sprintf(szLineout, "Writing results to %s", LogFileName);
	PutMsg (szLineout);

	getcwd(LogFileNameFull, 64);
	strcat(LogFileNameFull,"\\");
	strcat(LogFileNameFull, LogFileName);

	FileLogH = fopen (LogFileNameFull, "a+");



	if (Reply.Event0Ring == 30)
		strcpy(Ring0Str,"0-3");
	if (Reply.Event0Ring == 0)
		strcpy(Ring0Str,"0  ");
	if (Reply.Event0Ring == 3)
		strcpy(Ring0Str,"123");

	if (Reply.Event1Ring == 30)
		strcpy(Ring1Str,"0-3");
	if (Reply.Event1Ring == 0)
		strcpy(Ring1Str,"0  ");
	if (Reply.Event1Ring == 3)
		strcpy(Ring1Str,"123");

	time(&time1);

	fprintf (FileLogH, "\n\n--------- Log ---------\n");
	fprintf (FileLogH, ctime(&time1));

	fprintf (FileLogH, "CPU ID: Family= %u, Model= %u, Stepping= %u, FeatureFlags= %8lX\n",
					((CPUID_FamilyModelStepping>>8)&0xF),	
					((CPUID_FamilyModelStepping>>4)&0xF),	
					((CPUID_FamilyModelStepping>>0)&0xF),	
					CPUID_FeatureFlags
					);
	fprintf (FileLogH, "User Message:\t%s\n", LogMessage);

	fprintf(FileLogH,
					"Counter 0:\t%I64u\n"
					"Counter 1:\t%I64u\n"
					"Elapsed cycles (TSC):\t%I64u\n"
					,
					*ReplyT0 & 0xFFFFFFFFFF,
					*ReplyT1 & 0xFFFFFFFFFF,
					*ReplyElapsed
					);

	if (Which_CPU != PentiumPro)
		fprintf(FileLogH,"CESR:\t%08lX\n", Reply.res5);
	else
		fprintf(FileLogH,"PerfEvtSel 0:\t\t%08lX\tPerfEvtSel 1:\t%08lX\n", Reply.res5,Reply.res6);

	fprintf(FileLogH,"Cnt0 E:\t%08lX\tRing:\t%s\tUMask0=%02X\n", 
									Reply.res5, Ring0Str, Reply.Event0Mask);
	fprintf(FileLogH,"Cnt1 E:\t%08lX\tRing:\t%s\tUMask1=%02X\n", 
									Reply.res6, Ring1Str, Reply.Event1Mask);

	fprintf (FileLogH, "Event 0[%u]:\t%s\nEvent 1[%u]:\t%s\n", 
					Reply.Event0, Pmon32Event0ToStr(Reply.Event0), 
					Reply.Event1, Pmon32Event0ToStr(Reply.Event1));

	fprintf (FileLogH, "--------- Log End------");
	fclose(FileLogH);
}

void		WriteAccumulateCountersToLogFile(void)
{
	int i;
//	double z[6];
	time_t time1;
	char	R0[4];
	char	R1[4];

	char	IntervalLogNameFull [128];


	getcwd(IntervalLogNameFull, 100);
	strcat(IntervalLogNameFull,"\\");
	strcat(IntervalLogNameFull, IntervalLogName);

	sprintf(szLineout1,"Trace File = %s", IntervalLogNameFull);
	PutMsg(szLineout1);

	IntervalLog = fopen(IntervalLogNameFull,"a+");

	time(&time1);
	strcpy(szLineout1,ctime(&time1));

	fprintf (IntervalLog, "\n\n--->> Trace From: %s\n", szLineout1);

	sprintf (szLineout, "CPU ID:\tFamily\tModel\tStepping\tFeatureFlags");
	fprintf (IntervalLog, "%s\n", szLineout);
	sprintf (szLineout, "       \t   %u\t  %u\t       %u\t        %lX",
					((CPUID_FamilyModelStepping>>8)&0xF),	
					((CPUID_FamilyModelStepping>>4)&0xF),	
					((CPUID_FamilyModelStepping>>0)&0xF),	
					CPUID_FeatureFlags
					);
	if ( (CPUID_FeatureFlags&0x800000)==0x800000)
		strcat(szLineout, "\tMMX technology");

	fprintf (IntervalLog, "%s\n", szLineout);

	fprintf (IntervalLog, "User Message:\t%s\n", LogMessage);
	fprintf (IntervalLog, "Interval used:\t%u\t[ms]\n", Interval);
	
	if (Reply.Event0Ring == 30)
		strcpy(R0,"0-3");
	if (Reply.Event0Ring == 0)
		strcpy(R0,"0  ");
	if (Reply.Event0Ring == 3)
		strcpy(R0,"123");

	if (Reply.Event1Ring == 30)
		strcpy(R1,"0-3");
	if (Reply.Event1Ring == 0)
		strcpy(R1,"0  ");
	if (Reply.Event1Ring == 3)
		strcpy(R1,"123");

	fprintf(IntervalLog,"Cnt0 Ring:\t%s\tUMask0=%02X\n", R0, Reply.Event0Mask);
	fprintf(IntervalLog,"Cnt1 Ring:\t%s\tUMask1=%02X\n", R1, Reply.Event1Mask);
	
	if (Which_CPU != PentiumPro)
		fprintf(IntervalLog,"CESR:\t%08lX\n", Reply.res5);
	else
		fprintf(IntervalLog,"PerfEvtSel 0:\t%08lX\t\tPerfEvtSel 1:\t%08lX\n", Reply.res5,Reply.res6);


	fprintf (IntervalLog, "Event 0[%u]:\t%s\nEvent 1[%u]:\t%s\n", 
			Reply.Event0, Pmon32Event0ToStr(Reply.Event0), 
			Reply.Event1, Pmon32Event0ToStr(Reply.Event1));
			
	fprintf (IntervalLog,"\nSample#\tCnt0\tCnt1\tElapsed Cycles\n");

	for(i = 1; i < TableCount; i++) {
		fprintf(IntervalLog,"%05d\t%I64u\t%I64u\t%I64u\n", i, 
			EventTable[i].T0 - EventTable[i-1].T0,
			EventTable[i].T1 - EventTable[i-1].T1,
			EventTable[i].TSC - EventTable[i-1].TSC);
	}
	fprintf(IntervalLog,"\nTotal:\t%I64u\t%I64u\t%I64u\n", 
						EventTable[TableCount-1].T0 - EventTable[0].T0,
						EventTable[TableCount-1].T1 - EventTable[0].T1,
						EventTable[TableCount-1].TSC - EventTable[0].TSC);
	fprintf (IntervalLog, "\n--------- End ------");
	fclose(IntervalLog);
}

