
#define STRICT

#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <commdlg.h>
#include "genericr.h"

#define _export


void PutMsg (char *msg);
void InitComboBox(HWND hComboBox, char *initArray,
				  int initArraySize, int initArrayValSize, char *selection);


void InitComboBox(HWND hComboBox, char *Array,
				  int ArraySize, int ArrayValSize, char *selection);

void	PrintCounters(void);
void	PrintCounters2DebugWin(void);
void	PrintTimeStampCounter(void);

BOOL	GetRequestedEvent(void);

void	CreateEventsComboBoxs(void);
void	SelectEventsInComboBox(int event0, int event1);

void ChangeEvents();

void PrintElapsedTime(void);
void PrintTimeStampCounter(void);
void PrintCounters2DebugWin(void);
void PrintCounters(void);

void	SaveToIniFile(void);
void	ExecuteInBatch(void);
void	WriteCounterStopResultsToLogFile(void);
void		WriteAccumulateCountersToLogFile(void);

BOOL	LoadDLL_GetProcAddress();

void CALLBACK AutoCaptureTimerProc(HWND hWnd,UINT msg,UINT idTimer,DWORD dwTime);
BOOL CALLBACK ConfigDlgProc(HWND dWnd, WORD wMsg, WORD wParam, DWORD lParam);


void StartAccumulate(void);
void StopAccumulate(void);

void SimpleStart(void);
void SimpleStop(void);

void ExecuteInBatch();

void	ParseCommandLine(LPSTR lpCmdLine);
void ExecuteInBatch(void);
void UpdateCPUIDFlgs (void);
void	InstallEvents(void);


void	HandleINIFile(void);
void	UpdateDialogWithLastSelection(void);


void upper(char *string);

struct event {
		char 	str[53];
		BYTE	encoding;
};
extern struct event Events[];
extern struct event Events0p55C[];
extern struct event Events1p55C[];

struct	p6_pmon_struct{
	BYTE	encoding;
	BYTE	umask;
	char	str[53];
};

extern struct event Events[];
extern struct event Events0p55C[];
extern struct event Events1p55C[];
struct	p6_pmon_struct	PentiumPro_events[];

extern struct	Pmon32Reply	Reply;
extern	struct	Pmon32StartCmd	StartCmd;

extern unsigned	__int64	*ReplyT0, *ReplyT1, *ReplyTSC, *ReplyElapsed;

struct	MonitorStateStruct{
		unsigned long int	cnt0_l;
		unsigned long int	cnt0_h;
		unsigned long int	cnt1_l;
		unsigned long int	cnt1_h;
		unsigned long int	tsc_l;
		unsigned long int	tsc_h;
		unsigned long int	ElapsedTime_l;
		unsigned long int	ElapsedTime_h;
};

extern struct	MonitorStateStruct	MState;

struct Two32Struct{
	DWORD	l;
	DWORD	h;
};

struct EventEntry {
	union	{
		struct	Two32Struct	cnt0;
		unsigned	__int64	T0;
	};
	union	{
		struct	Two32Struct	cnt1;
		unsigned	__int64	T1;
	};
	union	{
		struct	Two32Struct	tsc;
		unsigned	__int64	TSC;
	};
/*
	DWORD cnt0_l;
	DWORD cnt0_h;
	DWORD cnt1_l;
	DWORD cnt1_h;
	DWORD tsc_l;
	DWORD tsc_h;
*/
};
extern struct EventEntry EventTable[];
extern int TableCount;


extern HWND  hWnd;
extern HINSTANCE hInst;  /* current instance */
extern int	 	MainWinWidth;
extern int 	MainWinHight;
extern HWND MainDlg;
extern HANDLE gHPmon;
extern HINSTANCE hLibrary1;

extern FILE *IntervalLog;
extern char IntervalLogName[32];
extern int Interval;
extern int BufferSize, DelayAfterStart, Auto_Stop_Time;

extern	int 	DisplayRefreshTimer, AutoCaptureTimer;

extern HWND asWnd, ListWnd, Counter0Wnd, Counter1Wnd,
		TSCWnd, CESR0Wnd, CESR1Wnd, Event0Wnd, Event1Wnd,
		Label0Wnd, Label1Wnd,
		MMxWnd,ElapsedTimeWnd, T0CodeWnd, T1CodeWnd,
		START_COUNTERS_Wnd,  TSCLabelWnd, CESRLabelWnd, CESRLabel1Wnd,
		START_AUTO_CAPTURE_COUNTERS_Wnd, T0IndexWnd, T1IndexWnd;


extern HWND START_COUNTERS_Wnd,  TSCLabelWnd, CESRLabelWnd;
extern	HWND	Cnt0_L3Wnd, Cnt0_L012Wnd,Cnt1_L3Wnd, Cnt1_L012Wnd;
extern HWND	Event0MaskWnd, Event1MaskWnd;

extern DWORD	ReqCnt0L012, ReqCnt0L3, ReqCnt1L012, ReqCnt1L3;

extern char szLineout[];
extern char szLineout1[];
extern char MainWindowTitle [100];
extern char IniFile [];
extern FILE * FileLogH;

extern	BOOL	InterActiveMode;
extern	BOOL	P55C_mode;
extern	BOOL	reload_vxd, BatchMode;

extern BOOL	PmonConnectionEstablished;

extern struct Pmon32Version Ver;
extern char Version	[];
extern int	AppMajor, AppMinor;

extern	int	CounterState;

#define	Pentium		1
#define	PentiumPro	2
extern BYTE	Which_CPU;
extern	DWORD	CPUID_FeatureFlags, CPUID_FamilyModelStepping;


BYTE	ReqCnt0Ring;
BYTE	ReqCnt1Ring;
extern	BYTE	T0ReqEvent, T0ReqMask;
extern	BYTE	T1ReqEvent, T1ReqMask;

extern	BOOL	MMxSupport;
extern	BOOL	StartReq, StopReq;
extern	BOOL	FileLogReq;
extern	BOOL	unload_vxd_on_exit ,Capture_ON , AccumulateMode;
extern	BOOL	StartDelayMode;

extern	int	Interval, Delay;

extern	char	LogFileName[64], LogMessage[100];
extern	char	PmonIniFileName [];
extern	char	ExecFile [];


extern char defEvent[54];
extern char selEvent[54];

extern int NumberOfDBFiles;
extern int NumberOfDBFilesP55c, NumberOfDBFilesPPro;

extern int	LastEvent0Selected, LastEvent1Selected;
extern int	LastRingForCnt0Selected, LastRingForCnt1Selected,
			LastMaskForCnt0Selected, LastMaskForCnt1Selected;



#define MAXEVENT 10000


#define	VxD_ID			0x4895
#define T0EVENT			100
#define T1EVENT			101
#define T0CPL			102
#define T1CPL			103
#define START			104
#define STOP			105
#define LOGFILE			106
#define LOGMSG			107
#define P55C			109
#define UNLOAD_VXD_ON_EXIT	110
#define	AUTO_START		112
#define	INTERVAL		113
#define	SAMPLES			114

#define	START_ACC			115
#define	EXEC_FILE			116
#define	DELAY				117

#define	BATCH				118
#define	INTERACTIVE			119
#define	NO_GUI				120
#define	START_DELAY			121


#define SEARCH_FROM_BEGINNING -1

#define CHECKED	1


#define EVENT_STRING_LENGTH	53
