/***************************************************************
Subject to the terms and conditions set forth below, Intel hereby 
grants you a nonexclusive, nontransferable license, under its 
patents and copyrights on the example source code sequences listed 
below,  to use, reproduce and distribute such example source code 
sequences, in object code format, solely as part of your computer 
program(s) and solely in order to allow your computer program(s) 
to implement the multimedia instruction extensions contained in 
such sequences solely with respect to the Intel instruction set 
architecture.  No other license, express, implied, statutory, by 
estoppel or otherwise, to any other intellectual property rights 
is granted herein.

THE EXAMPLE SOURCE CODE SEQUENCES LISTED BELOW ARE  PROVIDED "AS IS" 
WITH NO WARRANTIES, EXPRESS, IMPLIED, STATUTORY OR OTHERWISE, AND INTEL 
SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF MERCHANTABILITY,  
NONINFRINGEMENT OR FITNESS FOR ANY PARTICULAR PURPOSE.

Any use or distribution of  example source code sequences listed below 
must  fully comply with all then current laws of the United States 
including, without limitation, rules and regulations of the 
United States Office of Export Administration and other applicable 
U.S. governmental agencies.
 
IN NO EVENT WILL INTEL BE LIABLE FOR ANY DAMAGES OF ANY KIND, INCLUDING 
DIRECT OR INDIRECT DAMAGES, LOSS OF DATA, LOST PROFITS, COST OF COVER OR 
SPECIAL, INCIDENTAL, CONSEQUENTIAL, DAMAGES ARISING FROM THE USE OF THE 
EXAMPLE SOURCE CODE SEQUENCES LISTED BELOW, HOWEVER CAUSED AND ON ANY 
THEORY OF LIABILITY.  THIS LIMITATION WILL APPLY EVEN IF INTEL OR ANY 
AUTHORIZED AGENT OF INTEL HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH 
DAMAGE.

Copyright c 1996 Intel Corporation 
***********************************************************************/
/**********************************************************************/

/* system header files */
#include <windows.h>
#include <stdio.h>
#include <time.h>
#include <dos.h>
#include <io.h>
#include <stdlib.h>
#include <sys\stat.h>

/* specific headers and definitions for this program */
#include "pmapp.h"
#include "resource.h"

#include "dll_if.h"

char Version	[]	= "V2.2";
int	AppMajor		= 2;
int	AppMinor		= 200;

struct Pmon32Version Ver;

int BufferSize, DelayAfterStart;
int AutoCaptureTimer, DisplayRefreshTimer;

int TableCount;
struct EventEntry EventTable[MAXEVENT];

char	PmonIniFileName []	= "pmon.ini";
char	LogFileName[]		= "pmon32.log"; //stop results under non interactive
char	IntervalLogName[]	= "Trace.txt"; // Accumulate results
char	LogMessage[100]={" "};

FILE *IntervalLog;
FILE * FileLogH;


HWND  hWnd; // Main window handle.
char szLineout[1024];
char szLineout1[512];
HINSTANCE hInst;  /* current instance */
HINSTANCE hLibrary1;

DWORD	CPUID_FeatureFlags, CPUID_FamilyModelStepping;


struct	Pmon32Reply	Reply;
struct	Pmon32StartCmd	StartCmd;
unsigned	__int64	*ReplyT0, *ReplyT1, *ReplyTSC, *ReplyElapsed;

struct	MonitorStateStruct	MState;

DWORD	ReqCnt0L012, ReqCnt0L3, ReqCnt1L012, ReqCnt1L3;
BYTE	Cnt0_encoding , Cnt1_encoding;

BYTE	ReqCnt0Ring;
BYTE	ReqCnt1Ring;

BYTE	T0ReqEvent, T0ReqMask;
BYTE	T1ReqEvent, T1ReqMask;

BYTE	Which_CPU					= Pentium;
BOOL	MMxSupport					= FALSE;
BOOL	StartReq					= FALSE;
BOOL	StopReq						= FALSE;
BOOL	FileLogReq					= FALSE;
BOOL	P55C_mode					= FALSE;

BOOL	CounterState;
BOOL	unload_vxd_on_exit			= FALSE;
BOOL	Capture_ON					= FALSE;
BOOL	AutoStart					= FALSE;
BOOL	InterActiveMode				= TRUE;
BOOL	AccumulateMode				= FALSE;
BOOL	GUI_mode					= TRUE;
BOOL	PmonConnectionEstablished	= FALSE;
BOOL	BatchMode					= FALSE;
BOOL	StartDelayMode				= FALSE;

int	Interval=0;
int	Delay=0;

int	LastEvent0Selected, LastEvent1Selected;
int	LastRingForCnt0Selected, LastRingForCnt1Selected;
int	LastMaskForCnt0Selected, LastMaskForCnt1Selected;

int index = 0;



BOOL LoadDLL_GetProcAddress(void);


//==============================
void SimpleStart(){

	LastEvent0Selected		= T0ReqEvent;
	LastEvent1Selected		= T1ReqEvent;
	LastRingForCnt0Selected = ReqCnt0Ring;
	LastRingForCnt1Selected = ReqCnt1Ring;
	LastMaskForCnt0Selected	= T0ReqMask;
	LastMaskForCnt1Selected	= T1ReqMask;

	StartCmd.Event0			= T0ReqEvent;
	StartCmd.Event1			= T1ReqEvent;
	StartCmd.Event0Ring		= ReqCnt0Ring;
	StartCmd.Event1Ring		= ReqCnt1Ring;

	if (Which_CPU == PentiumPro)
	{
		StartCmd.Event0Mask = T0ReqMask;
		StartCmd.Event1Mask = T1ReqMask;
	}
	else
	{
		StartCmd.Event0Mask = 0;
		StartCmd.Event1Mask = 0;
	}

	Pmon32StartEx	 (&StartCmd);
}

// ==================================================
void SimpleStop(){
	Pmon32StopAndReadCounters	(&Reply);

	MState.cnt0_h			=	Reply.T0_h ;
	MState.cnt0_l			=	Reply.T0_l ;
	MState.cnt1_h			=	Reply.T1_h ;
	MState.cnt1_l			=	Reply.T1_l ;
	MState.ElapsedTime_h	=	Reply.ElapsedTime_h ;
	MState.ElapsedTime_l	=	Reply.ElapsedTime_l ;
}

//========================

void StartAccumulate(){

	LastEvent0Selected		= T0ReqEvent;
	LastEvent1Selected		= T1ReqEvent;
	LastRingForCnt0Selected = ReqCnt0Ring;
	LastRingForCnt1Selected = ReqCnt1Ring;
	LastMaskForCnt0Selected	= T0ReqMask;
	LastMaskForCnt1Selected	= T1ReqMask;

	StartCmd.Event0			= T0ReqEvent;
	StartCmd.Event1			= T1ReqEvent;
	StartCmd.Event0Ring		= ReqCnt0Ring;
	StartCmd.Event1Ring		= ReqCnt1Ring;

	
	if (Which_CPU == PentiumPro)
	{
		StartCmd.Event0Mask = T0ReqMask;
		StartCmd.Event1Mask = T1ReqMask;
	}
	else
	{
		StartCmd.Event0Mask = 0;
		StartCmd.Event1Mask = 0;
	}

	TableCount = 0;
	Capture_ON = TRUE;	

	Pmon32StartEx	 (&StartCmd);

	if (Which_CPU != PentiumPro)
		sprintf(szLineout,"Running With: CESR = %04X  %04X", (WORD)(StartCmd.Res1>>16), (WORD)StartCmd.Res1);
	else
		sprintf(szLineout,"Running With: PerfEvtSel 0: %08lX, PerfEvtSel 1: %08lX", StartCmd.Res1,StartCmd.Res2);
	PutMsg (szLineout);
}

// ==================================================
void StopAccumulate(){
	Capture_ON = FALSE;
		
	Pmon32StopAndReadCounters	(&Reply);

	MState.cnt0_h			=  Reply.T0_h ;
	MState.cnt0_l			=  Reply.T0_l ;
	MState.cnt1_h			=  Reply.T1_h ;
	MState.cnt1_l			=  Reply.T1_l ;
	MState.ElapsedTime_h	=  Reply.ElapsedTime_h ;
	MState.ElapsedTime_l	=  Reply.ElapsedTime_l ;

	if (Which_CPU != PentiumPro)
		sprintf(szLineout,"....[Stopped] CESR: %04X  %04X", (WORD)(Reply.res5>>16), (WORD)Reply.res5);
	else
		sprintf(szLineout,"....[Stopped] PerfEvtSel 0: %08lX, PerfEvtSel 1: %08lX", Reply.res5,Reply.res6);
	PutMsg (szLineout);

	WriteAccumulateCountersToLogFile();
}

//==============================
void CALLBACK AutoCaptureTimerProc(HWND hWnd,UINT msg,UINT idTimer,DWORD dwTime){

	if (Capture_ON == FALSE)
	return;	
	if (PmonConnectionEstablished == FALSE)
	return;

				//store counter readings into the table
	if(TableCount < MAXEVENT) {
		Pmon32ReadCounters(&Reply);
	
		EventTable[TableCount].cnt0.l = Reply.T0_l;
		EventTable[TableCount].cnt0.h = Reply.T0_h;
		EventTable[TableCount].cnt1.l = Reply.T1_l;
		EventTable[TableCount].cnt1.h = Reply.T1_h;
	
		EventTable[TableCount].tsc.l  = Reply.TSC_l;
		EventTable[TableCount].tsc.h  = Reply.TSC_h;
	}

	TableCount++;

	if(TableCount == BufferSize) {
		sprintf (szLineout, "   %u entries in buffer. Stopped Capturing.", BufferSize);
	 	PutMsg (szLineout);
		Capture_ON = FALSE;
		SendMessage (MainDlg, 	WM_COMMAND, IDC_ACCUMULATIVE_START_STOP, 0); // 1-checked, 0-unchecked
	}
}


BOOL GetRequestedEvent(void)
{
	int	ReqCnt0L3, ReqCnt0L012, ReqCnt1L3, ReqCnt1L012;

	ReqCnt0Ring = 0xFF;
	ReqCnt1Ring = 0xFF;

	ReqCnt0L3 	= SendMessage (Cnt0_L3Wnd, 		BM_GETCHECK, 0, 0);
	ReqCnt0L012 = SendMessage (Cnt0_L012Wnd, 	BM_GETCHECK, 0, 0);
	ReqCnt1L3 	= SendMessage (Cnt1_L3Wnd, 		BM_GETCHECK, 0, 0);
	ReqCnt1L012 = SendMessage (Cnt1_L012Wnd, 	BM_GETCHECK, 0, 0);

	if ((ReqCnt0L3==1) & (ReqCnt0L012==1))
		ReqCnt0Ring=30;
	if ((ReqCnt0L3==1) & (ReqCnt0L012==0))
		ReqCnt0Ring=3;
	if ((ReqCnt0L3==0) & (ReqCnt0L012==1))
		ReqCnt0Ring=0;

	if	(ReqCnt0Ring == 0xFF)
		return FALSE;

	if ((ReqCnt1L3==1) & (ReqCnt1L012==1))
		ReqCnt1Ring=30;
	if ((ReqCnt1L3==1) & (ReqCnt1L012==0))
		ReqCnt1Ring=3;
	if ((ReqCnt1L3==0) & (ReqCnt1L012==1))
		ReqCnt1Ring=0;

	if	(ReqCnt1Ring == 0xFF)
		return FALSE;


	T0ReqMask	= (BYTE) SendMessage (Event0MaskWnd,	CB_GETCURSEL, 0, 0); 
	T1ReqMask	= (BYTE) SendMessage (Event1MaskWnd,	CB_GETCURSEL, 0, 0); 
	T0ReqEvent	= (BYTE) SendMessage (Event0Wnd,		CB_GETCURSEL, 0, 0); 
	T1ReqEvent	= (BYTE) SendMessage (Event1Wnd,		CB_GETCURSEL, 0, 0); 
	return TRUE;
}

BOOL LoadDLL_GetProcAddress(void){
	hLibrary1 = LoadLibrary("PM32_DLL.DLL"); 
   	if (hLibrary1==NULL){
		MessageBox(NULL,"Couldn't find the DLL PM32_DLL.DLL, does not exist","Error", MB_ICONINFORMATION); 
		return (FALSE);
	}
	else{
		(FARPROC) Pmon32Init				= GetProcAddress(hLibrary1, "Pmon32Init");
		(FARPROC) Pmon32Close				= GetProcAddress(hLibrary1, "Pmon32Close");
		(FARPROC) Pmon32Status				= GetProcAddress(hLibrary1, "Pmon32Status");
		(FARPROC) Pmon32Start				= GetProcAddress(hLibrary1, "Pmon32Start");
		(FARPROC) Pmon32StopAndReadCounters = GetProcAddress(hLibrary1, "Pmon32StopAndReadCounters");
		(FARPROC) Pmon32AreCountersRunning	= GetProcAddress(hLibrary1, "Pmon32AreCountersRunning");
		(FARPROC) Pmon32ReadCounters		= GetProcAddress(hLibrary1, "Pmon32ReadCounters");
		(FARPROC) Pmon32ReadTSC				= GetProcAddress(hLibrary1, "Pmon32ReadTSC");

		(FARPROC) Pmon32EnableRDPMCRing3	= GetProcAddress(hLibrary1, "Pmon32EnableRDPMCRing3");
		(FARPROC) Pmon32DisableRDPMCRing3	= GetProcAddress(hLibrary1, "Pmon32DisableRDPMCRing3");
		(FARPROC) Pmon32Event0ToStr			= GetProcAddress(hLibrary1, "Pmon32Event0ToStr");
		(FARPROC) Pmon32Event1ToStr			= GetProcAddress(hLibrary1, "Pmon32Event1ToStr");

// new ones
		(FARPROC) Pmon32StartDirect			= GetProcAddress(hLibrary1, "Pmon32StartDirect");
		(FARPROC) Pmon32InstallEvent		= GetProcAddress(hLibrary1, "Pmon32InstallEvent");
		(FARPROC) Pmon32StartEx				= GetProcAddress(hLibrary1, "Pmon32StartEx");
		(FARPROC) Pmon32InitEx				= GetProcAddress(hLibrary1, "Pmon32InitEx");

// undocumented/ not tested
		(FARPROC) ReadMSR					= GetProcAddress(hLibrary1, "ReadMSR");
		(FARPROC) ReadModifWriteMSR			= GetProcAddress(hLibrary1, "ReadModifWriteMSR");

		return (TRUE);
	}
}