/***************************************************************
Subject to the terms and conditions set forth below, Intel hereby 
grants you a nonexclusive, nontransferable license, under its 
patents and copyrights on the example source code sequences listed 
below,  to use, reproduce and distribute such example source code 
sequences, in object code format, solely as part of your computer 
program(s) and solely in order to allow your computer program(s) 
to implement the multimedia instruction extensions contained in 
such sequences solely with respect to the Intel instruction set 
architecture.  No other license, express, implied, statutory, by 
estoppel or otherwise, to any other intellectual property rights 
is granted herein.

THE EXAMPLE SOURCE CODE SEQUENCES LISTED BELOW ARE  PROVIDED "AS IS" 
WITH NO WARRANTIES, EXPRESS, IMPLIED, STATUTORY OR OTHERWISE, AND INTEL 
SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF MERCHANTABILITY,  
NONINFRINGEMENT OR FITNESS FOR ANY PARTICULAR PURPOSE.

Any use or distribution of  example source code sequences listed below 
must  fully comply with all then current laws of the United States 
including, without limitation, rules and regulations of the 
United States Office of Export Administration and other applicable 
U.S. governmental agencies.
 
IN NO EVENT WILL INTEL BE LIABLE FOR ANY DAMAGES OF ANY KIND, INCLUDING 
DIRECT OR INDIRECT DAMAGES, LOSS OF DATA, LOST PROFITS, COST OF COVER OR 
SPECIAL, INCIDENTAL, CONSEQUENTIAL, DAMAGES ARISING FROM THE USE OF THE 
EXAMPLE SOURCE CODE SEQUENCES LISTED BELOW, HOWEVER CAUSED AND ON ANY 
THEORY OF LIABILITY.  THIS LIMITATION WILL APPLY EVEN IF INTEL OR ANY 
AUTHORIZED AGENT OF INTEL HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH 
DAMAGE.

Copyright c 1996 Intel Corporation 
***********************************************************************/
/**********************************************************************/

/* system header files */
#include <windows.h>
#include <stdio.h>
#include <time.h>
#include <dos.h>
//#include <dir.h>
#include <io.h>
#include <stdlib.h>
#include <sys\stat.h>

/* specific headers and definitions for this program */
#include "pmapp.h"
#include "genericr.h"

#include "dll_if.h"


void PrintCounters(void)
{
	Pmon32ReadCounters	(&Reply);
	MState.cnt0_h		=  Reply.T0_h ;
	MState.cnt0_l		=  Reply.T0_l ;
	MState.cnt1_h		=  Reply.T1_h ;
	MState.cnt1_l		=  Reply.T1_l ;

	sprintf(szLineout,	"%I64u", *ReplyT0);
	sprintf(szLineout1,	"%I64u", *ReplyT1);

	SendMessage(Counter0Wnd, WM_CLEAR , 0, 0);
	SendMessage(Counter0Wnd, WM_SETTEXT , 0, (LPARAM)(LPCTSTR)szLineout);
	SendMessage(Counter1Wnd, WM_CLEAR , 0, 0);
	SendMessage(Counter1Wnd, WM_SETTEXT , 0, (LPARAM)(LPCTSTR)szLineout1);

	SetDlgItemText(MainDlg, IDC_COUNTER0, szLineout);
}

void PrintCounters2DebugWin(void)
{
	char	tmp[20];


	if (Reply.Event0Ring == 30)
		strcpy(tmp,"0-3");
	else
		if (Reply.Event0Ring == 0)
			strcpy(tmp,"0  ");
		else
			if (Reply.Event0Ring == 3)
				strcpy(tmp,"123");
			else
				strcpy(tmp," ? ");

	if (Which_CPU != PentiumPro)
		sprintf(szLineout,"Event 0[%u]: %s, R=%s",Reply.Event0,
							Pmon32Event0ToStr(Reply.Event0),tmp);
	else
		sprintf(szLineout,"Event 0[%u]: %s, R=%s, UM=%02X",Reply.Event0,
							Pmon32Event0ToStr(Reply.Event0),tmp,
							Reply.Event0Mask);
	PutMsg (szLineout);

	if (Reply.Event1Ring == 30)
		strcpy(tmp,"0-3");
	if (Reply.Event1Ring == 0)
		strcpy(tmp,"0  ");
	if (Reply.Event1Ring == 3)
		strcpy(tmp,"123");
	if (Which_CPU != PentiumPro)
		sprintf(szLineout,"Event 1[%u]: %s, R=%s", Reply.Event1,
							Pmon32Event1ToStr(Reply.Event1),tmp);
	else
		sprintf(szLineout,"Event 1[%u]: %s, R=%s, UM=%02X", Reply.Event1,
							Pmon32Event1ToStr(Reply.Event1),tmp,
							Reply.Event1Mask);
	PutMsg (szLineout);

	sprintf(szLineout,"Cnt0= %I64u       Cnt1= %I64u      [%I64u Elapsed cycles]",
										*ReplyT0, *ReplyT1,
										*ReplyElapsed);
	PutMsg (szLineout);
}

void PrintTimeStampCounter(void)
{
	Pmon32ReadTSC		(&Reply);

	sprintf(szLineout,	"%I64u", *ReplyTSC);
	
	SendMessage(TSCWnd, WM_CLEAR , 0, 0);
	SendMessage(TSCWnd, WM_SETTEXT , 0, (LPARAM)(LPCTSTR)szLineout);
}

void PrintElapsedTime(void){
	sprintf(szLineout,	"%08lX %08lX", MState.ElapsedTime_h,
										MState.ElapsedTime_l);
	SendMessage(ElapsedTimeWnd, WM_CLEAR , 0, 0);
	SendMessage(ElapsedTimeWnd, WM_SETTEXT , 0, (LPARAM)(LPCTSTR)szLineout);
}




void UpdateCPUIDFlgs (void){
DWORD	tmp1, tmp2;

	_asm{
			push	ebx

			mov	eax, 1  			// case 1
			_emit 0x0F		// cpuid
			_emit 0xA2		// cpuid

			mov	tmp1, eax	// model etc
			mov	tmp2, edx	// Features flags
			
			pop		ebx
	}

	CPUID_FamilyModelStepping			= tmp1;
	CPUID_FeatureFlags					= tmp2;

	if ((tmp2 & 0x800000)==0x800000)
		MMxSupport = TRUE;

	if ((tmp1 & 0x00000f00) == 0x500)
			Which_CPU = Pentium;
	else{
		if ((tmp1 & 0x00000f00) == 0x600)
				Which_CPU = PentiumPro;
		else
				Which_CPU = 0xff;
	}
}
