/***************************************************************
Subject to the terms and conditions set forth below, Intel hereby 
grants you a nonexclusive, nontransferable license, under its 
patents and copyrights on the example source code sequences listed 
below,  to use, reproduce and distribute such example source code 
sequences, in object code format, solely as part of your computer 
program(s) and solely in order to allow your computer program(s) 
to implement the multimedia instruction extensions contained in 
such sequences solely with respect to the Intel instruction set 
architecture.  No other license, express, implied, statutory, by 
estoppel or otherwise, to any other intellectual property rights 
is granted herein.

THE EXAMPLE SOURCE CODE SEQUENCES LISTED BELOW ARE  PROVIDED "AS IS" 
WITH NO WARRANTIES, EXPRESS, IMPLIED, STATUTORY OR OTHERWISE, AND INTEL 
SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF MERCHANTABILITY,  
NONINFRINGEMENT OR FITNESS FOR ANY PARTICULAR PURPOSE.

Any use or distribution of  example source code sequences listed below 
must  fully comply with all then current laws of the United States 
including, without limitation, rules and regulations of the 
United States Office of Export Administration and other applicable 
U.S. governmental agencies.
 
IN NO EVENT WILL INTEL BE LIABLE FOR ANY DAMAGES OF ANY KIND, INCLUDING 
DIRECT OR INDIRECT DAMAGES, LOSS OF DATA, LOST PROFITS, COST OF COVER OR 
SPECIAL, INCIDENTAL, CONSEQUENTIAL, DAMAGES ARISING FROM THE USE OF THE 
EXAMPLE SOURCE CODE SEQUENCES LISTED BELOW, HOWEVER CAUSED AND ON ANY 
THEORY OF LIABILITY.  THIS LIMITATION WILL APPLY EVEN IF INTEL OR ANY 
AUTHORIZED AGENT OF INTEL HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH 
DAMAGE.

Copyright c 1996 Intel Corporation 
***********************************************************************/
/**********************************************************************/
#include <windows.h>
#include <stdio.h>
#include <time.h>
#include <dos.h>

/* specific headers and definitions for this program */
#include "pmapp.h"
#include "resource.h"
#include "dll_if.h"

void	InitEventsInComboBox(void);
BOOL	CALLBACK DlgProc(HWND dWnd, WORD wMsg, WORD wParam, DWORD lParam);
void	ChangeEvents(void);
void	InitMaskInComboBox(void);
void	InitEventIndexInComboBox(void);
void	GetWindowsHandles (void);

HWND MainDlg;
HWND	asWnd, ListWnd, Counter0Wnd, Counter1Wnd,
		TSCWnd, CESR0Wnd, CESR1Wnd, Event0Wnd, Event1Wnd,
		Label0Wnd, Label1Wnd,
		MMxWnd,ElapsedTimeWnd, T0CodeWnd, T1CodeWnd,
		START_COUNTERS_Wnd,  TSCLabelWnd, CESRLabelWnd, CESRLabel1Wnd,
		START_AUTO_CAPTURE_COUNTERS_Wnd;
HWND	Cnt0_L3Wnd, Cnt0_L012Wnd,Cnt1_L3Wnd, Cnt1_L012Wnd;
HWND	Event0MaskWnd, Event1MaskWnd, T0IndexWnd, T1IndexWnd, DelayedStartWnd,
		ControlPanelMenuH;

BOOL	StayOnTop				=	FALSE;
BOOL	AutoStopFlag			=	FALSE;
BOOL	DelayedStartFlag		=	FALSE;
BOOL	StartFlag				=	FALSE;
BOOL	AlwaysSaveResultsToFile	=	FALSE;

int Auto_Stop_Time;
int Local_Auto_Stop_Time;
int	LocalDelayAfterStart;

LPSTR	cmdptr;

/**************************************************************/
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
			  LPSTR lpCmdLine, int nCmdShow)
{
    WNDCLASS wndclass;

	hInst = hInstance;

	cmdptr = lpCmdLine;
        
	if ( !GetClassInfo( 0, MAKEINTRESOURCE(32770), &wndclass ) )
        return 0;
	wndclass.hInstance =  hInstance;
	wndclass.lpszClassName = "MAIN_CONTROL_DIALOG";
	wndclass.hIcon         = LoadIcon (hInstance, "IDI_ICON1");
    if ( !RegisterClass(&wndclass) )
        return 0;

	
	UpdateCPUIDFlgs ();


	if (LoadDLL_GetProcAddress()== FALSE)
		return FALSE;

	ParseCommandLine(lpCmdLine);

/*
	if (InterActiveMode == FALSE)
		StartCmd.unload_vxd_on_exit = FALSE; //This will save the triggering information
											 //In the resident VxD and will report
											 //it back when will be launched the second time
	else
		StartCmd.unload_vxd_on_exit = TRUE;	 // start and stop are on the same session so
											 // Vxd will be loaded and be updated all the time.
*/

	StartCmd.unload_vxd_on_exit = unload_vxd_on_exit;
	PmonConnectionEstablished = Pmon32InitEx	(&StartCmd, &Ver);

	if (PmonConnectionEstablished != Pmon32_OK)
		MessageBox(hWnd,"VxD connection has not been established\n"
				" Make sure the pmon.vxd file is in the same directory as this app",
							"Error connecting to VxD",MB_OK);

	InstallEvents();		// must be before the dialog to allow install + Non InterActiveMode

	ReplyT0			= (unsigned __int64*)&Reply.T0_l;
	ReplyT1			= (unsigned __int64*)&Reply.T1_l;
	ReplyTSC		= (unsigned __int64*)&Reply.TSC_l;
	ReplyElapsed	= (unsigned __int64*)&Reply.ElapsedTime_l;


	if (BatchMode == TRUE ){
		if (StopReq == TRUE){
			SimpleStop();
			if (FileLogReq == TRUE)
				WriteCounterStopResultsToLogFile();
			return 0;
		}

		if (StartReq == TRUE){
			CounterState=TRUE;
			SimpleStart();
			return 0;
		}
	}


	// You reach this point only if
	// Intercative or GUI  or Acumulate

	DialogBox(hInst, "MAIN_CONTROL_DIALOG", 0, DlgProc);

	Pmon32Close();
	
	return 0;

}


//========================================================================
BOOL CALLBACK DlgProc(HWND dWnd, WORD wMsg, WORD wParam, DWORD lParam)
{

HWND tmp;
int index;
RECT rect;
RECT rectDT;
HWND	tmph;
BYTE	Sel;

int i, count;
int	indexv[20];
HGLOBAL PtrH, PtrH1;
void  FAR *Ptr;
char  FAR *Ptr1;
time_t time1;
DWORD	dw;


	MainDlg = dWnd;

	switch(wMsg)
	{

	case WM_INITDIALOG:
		
		GetWindowsHandles ();



		if (Which_CPU != PentiumPro)
		{
			tmph = GetDlgItem(MainDlg, IDC_STATIC_MASK0);
			ShowWindow(tmph, SW_HIDE);
			tmph = GetDlgItem(MainDlg, IDC_STATIC_MASK1);
			ShowWindow(tmph, SW_HIDE);

			ShowWindow(Event0MaskWnd, SW_HIDE);
			ShowWindow(Event1MaskWnd, SW_HIDE);
		}


		sprintf( szLineout, "PMON Utility %s", Version);
		SetWindowText (dWnd, szLineout);

		sprintf(szLineout, "DLL - ( %s, %u.%u )", 
									Ver.DLLVersion, Ver.DLLMajor, Ver.DLLMinor);
		PutMsg (szLineout);
		if (PmonConnectionEstablished == Pmon32_OK){
			sprintf(szLineout, "VxD - ( %s, %u.%u )", 
									Ver.VxDVersion, Ver.VxDMajor, Ver.VxDMinor);
			PutMsg (szLineout);

			// V2.105 is last version that changed the data structure
			if	(
				(Ver.VxDMajor >= 2) && 
				(Ver.VxDMinor >= 105) &&
				(Ver.DLLMajor >= 2) &&
				(Ver.DLLMinor >= 105)
										)
				PmonConnectionEstablished = TRUE;
			else{
				PutMsg ("Version Error: App/DLL/VxD do not match");
				PutMsg ("     DLL/VxD shoud be >= V2.105");
			}
		}
		else{
			PutMsg ("");
			PutMsg ("VxD is not loaded. The file PMON.VXD must be in this directory");
			PutMsg ("");
			PutMsg ("Reading/Setting counters will not work.");
			PmonConnectionEstablished = FALSE;
		}

		dw	= GetVersion ();
		if ( (dw & 0x80000000L) == 0x80000000L )
			PutMsg (" Hello Win 95");
		else
			PutMsg (" Hello Win NT");

		if (AccumulateMode == TRUE)
			;
		else
			HandleINIFile();


		InitEventsInComboBox();
		InitMaskInComboBox();
		InitEventIndexInComboBox();

		Pmon32Status(&Reply);
		if (Reply.status == Pmon32_Counters_Running){
			CounterState=TRUE;
			if (Which_CPU != PentiumPro)
				sprintf(szLineout,"Running With: CESR = %04X  %04X", (WORD)(Reply.res5>>16), (WORD)Reply.res5);
			else
				sprintf(szLineout,"Running With: PerfEvtSel 0: %08lX, PerfEvtSel 1: %08lX", Reply.res5,Reply.res6);
			PutMsg (szLineout);
			SetWindowText(START_COUNTERS_Wnd, "Stop");
			SetWindowText(START_AUTO_CAPTURE_COUNTERS_Wnd, "Stop [Acc.]");
		}
		else{
			CounterState=FALSE;
			SetWindowText(START_COUNTERS_Wnd, "Start");
			SetWindowText(START_AUTO_CAPTURE_COUNTERS_Wnd, "Start [Acc.]");
		}
		UpdateDialogWithLastSelection();


		if (AccumulateMode == TRUE){
			ShowWindow(MainDlg, SW_HIDE);
			AutoCaptureTimer = SetTimer(MainDlg, 444, Interval, (TIMERPROC)AutoCaptureTimerProc);
			StartAccumulate();
			return TRUE;
		}
		else
			DisplayRefreshTimer = SetTimer ( MainDlg, 333, 1000, NULL);//for display values

		if (StartDelayMode == TRUE){
			PostMessage (MainDlg, 	WM_COMMAND, IDC_START_DELAY, 0);
			return TRUE;
		}

		return TRUE;

		case WM_CLOSE:
			SaveToIniFile();
			KillTimer(MainDlg, DisplayRefreshTimer);
			PostQuitMessage(0);
		return TRUE;

		case WM_TIMER:
			if (PmonConnectionEstablished == FALSE)
			break;
			PrintTimeStampCounter();
			PrintCounters();
			if (DelayedStartFlag==TRUE ){
				LocalDelayAfterStart--;
				if (LocalDelayAfterStart==0){
					SetWindowText(DelayedStartWnd, "Start [Delay]");
					DelayedStartFlag=FALSE;
					PostMessage (MainDlg, 	WM_COMMAND, IDC_START_BUTTON, 0);
				}
			}
			if (AutoStopFlag!=FALSE){  // checked
				Local_Auto_Stop_Time--;
				if (Local_Auto_Stop_Time==0)
					SendMessage (MainDlg, 	WM_COMMAND, IDC_START_BUTTON, 0);
			}
		break;

		case WM_COMMAND:
			switch(wParam)
			{
				case	IDC_ACCUMULATIVE_START_STOP:
					if (Pmon32Status(&Reply) != Pmon32_OK){
						PutMsg ("Sorry, the VxD is not loaded. Can not start");
						break;
					}
					if (Reply.status==Pmon32_Counters_Stopped){
						sprintf (szLineout, "   -->> In Accumulate Mode  [For %u sec]", 
								(Interval * BufferSize)/1000);
						PutMsg (szLineout);
						SetWindowText(START_AUTO_CAPTURE_COUNTERS_Wnd, "Stop [Acc.]");
						AutoCaptureTimer = SetTimer(MainDlg, 444, Interval, (TIMERPROC)AutoCaptureTimerProc);
						if (GetRequestedEvent()==TRUE){
							StartAccumulate();
						}
						else{
							PutMsg ("Sorry, Invalid selection.");
							MessageBeep(MB_ICONASTERISK);
						}
					}
					else{
						StopAccumulate();
						if (InterActiveMode == FALSE)
							SendMessage (MainDlg, 	WM_COMMAND, IDC_QUIT, 0);
						KillTimer(MainDlg, AutoCaptureTimer);
						SetWindowText(START_AUTO_CAPTURE_COUNTERS_Wnd, "Start [Acc.]");
						PrintCounters2DebugWin();
						if (AccumulateMode==TRUE){ // Now that it's all over we could be intrusive
							DisplayRefreshTimer = SetTimer ( MainDlg, 333, 1000, NULL);//for display values
							AccumulateMode=FALSE;
						}
						MessageBeep(MB_ICONASTERISK);
//debug
						ShowWindow(MainDlg, SW_SHOW);
					}
				break;

				case	IDC_START_DELAY:
					if (DelayAfterStart==0){
						SendMessage (MainDlg, 	WM_COMMAND, IDC_START_BUTTON, 0);
						break;
					}
					SetWindowText(START_COUNTERS_Wnd, "Wait...");
					SetWindowText(DelayedStartWnd	, "Wait...");
					LocalDelayAfterStart = DelayAfterStart;
					DelayedStartFlag=TRUE;
				break;

				case	IDC_START_BUTTON:
					if (Pmon32Status(&Reply) != Pmon32_OK){
						PutMsg ("Sorry, the VxD is not loaded. Can not start");
						break;
					}
					if (Reply.status==Pmon32_Counters_Stopped){
						if (GetRequestedEvent()==TRUE){
							SimpleStart();
							if (AutoStopFlag!=FALSE){
								Local_Auto_Stop_Time = Auto_Stop_Time;
								SetWindowText(START_COUNTERS_Wnd, "Stop [Auto]");
							}
							else
								SetWindowText(START_COUNTERS_Wnd, "Stop");
						}
						else{
							PutMsg ("Sorry, Invalid selection.");
							MessageBeep(MB_ICONASTERISK);
						}
					}
					else{
						if (Which_CPU != PentiumPro)
							sprintf(szLineout,"....[Stopped] CESR: %04X  %04X", (WORD)(Reply.res5>>16), (WORD)Reply.res5);
						else
							sprintf(szLineout,"....[Stopped] PerfEvtSel 0: %08lX, PerfEvtSel 1: %08lX", Reply.res5,Reply.res6);
						SimpleStop();
						PutMsg (szLineout);
						SetWindowText(START_COUNTERS_Wnd, "Start");
						PrintCounters2DebugWin();
						StartFlag = FALSE;
						if (AlwaysSaveResultsToFile == TRUE){
							WriteCounterStopResultsToLogFile();
						}
						MessageBeep(MB_ICONASTERISK);
						ShowWindow(MainDlg, SW_SHOW);
					}
				break;

				case	IDC_CONFIGURE:
					DialogBox(hInst, "CONFIGURATION_DIALOG", dWnd, ConfigDlgProc);
				break;

				case	IDC_EVENT0_INDEX:
					index = SendMessage (T0IndexWnd, CB_GETCURSEL, 0, 0);
					Sel = PentiumPro_events[index].umask;
					SendMessage (Event0MaskWnd, CB_SETCURSEL, (WPARAM)Sel, 0);
					SendMessage (Event0Wnd, CB_SETCURSEL, (WPARAM)index, 0);
				break;
				case	IDC_EVENT1_INDEX:
					index = SendMessage (T1IndexWnd, CB_GETCURSEL, 0, 0);
					Sel = PentiumPro_events[index].umask;
					SendMessage (Event1MaskWnd, CB_SETCURSEL, (WPARAM)Sel, 0);
					SendMessage (Event1Wnd, CB_SETCURSEL, (WPARAM)index, 0);
				break;
				case IDC_COUNTER0_EVENTS:
					index = SendMessage (Event0Wnd, CB_GETCURSEL, 0, 0);
					Sel = PentiumPro_events[index].umask;
					SendMessage (Event0MaskWnd, CB_SETCURSEL, (WPARAM)Sel, 0);
					SendMessage (T0IndexWnd, CB_SETCURSEL, (WPARAM)index, 0);
				break;
				case IDC_COUNTER1_EVENTS:
					index = SendMessage (Event1Wnd, CB_GETCURSEL, 0, 0); // 1-checked, 0-unchecked
					Sel = PentiumPro_events[index].umask;
					SendMessage (Event1MaskWnd, CB_SETCURSEL, (WPARAM)Sel, 0);
					SendMessage (T1IndexWnd, CB_SETCURSEL, (WPARAM)index, 0);
				break;
				case	IDC_SAVE_RESULTS_TO_FILE:
				case	IDC_SAVE_RESULTS_TO_CLIPBOARD:
													// You must select at least one line
					PtrH 	= GlobalAlloc(GPTR, 1024);
					Ptr		=  GlobalLock(PtrH);
					PtrH1 	= GlobalAlloc(GPTR, 150);
					Ptr1	=  GlobalLock(PtrH1);

					count 	= SendMessage(ListWnd, LB_GETSELITEMS, 20, (LPARAM)indexv);
					if (count>0){
						if (wParam == IDC_SAVE_RESULTS_TO_FILE){
							sprintf(szLineout, "Saved to %s ", IntervalLogName);
							PutMsg (szLineout);

							IntervalLog = fopen(IntervalLogName,"a+");
							time(&time1);
							strcpy(szLineout1,ctime(&time1));
							fprintf (IntervalLog, "\n\n------> %s%s\n\n", szLineout1, LogMessage);
						}
						if (wParam == IDC_SAVE_RESULTS_TO_CLIPBOARD){
							OpenClipboard ( MainDlg);
							EmptyClipboard();
						}
						for (i=0;i<count;i++){
							SendMessage(ListWnd,LB_GETTEXT, indexv[i], (LPARAM)GlobalLock(PtrH1));
							if (wParam == IDC_SAVE_RESULTS_TO_FILE)
								fprintf (IntervalLog, "%s\n", Ptr1);
							if (wParam == IDC_SAVE_RESULTS_TO_CLIPBOARD){
								strcat(Ptr1, "\r\n");
								strcat(Ptr, Ptr1);
							}
						}
						if (wParam == IDC_SAVE_RESULTS_TO_CLIPBOARD){
							SetClipboardData(CF_TEXT,  PtrH);
							CloseClipboard();
						}
						if (wParam == IDC_SAVE_RESULTS_TO_FILE){
							fprintf (IntervalLog, "-----> End", szLineout1, LogMessage);
							fclose(IntervalLog);
						}
					}
					else{
						PutMsg ("Sorry, first select lines at this window then, resubmit");
						MessageBeep(MB_ICONEXCLAMATION);
					}
					
				break;
				case	IDC_AUTO_STOP:
					AutoStopFlag = !AutoStopFlag;
					CheckMenuItem(ControlPanelMenuH, IDC_AUTO_STOP,
									MF_BYCOMMAND | 
									(AutoStopFlag? MF_CHECKED:MF_UNCHECKED));
				break;
				case	ID_SETTING_ALWAYSSAVERESULTSTOAFILE:
					AlwaysSaveResultsToFile = !AlwaysSaveResultsToFile;
					CheckMenuItem(ControlPanelMenuH, ID_SETTING_ALWAYSSAVERESULTSTOAFILE,
									MF_BYCOMMAND | 
									(AlwaysSaveResultsToFile? MF_CHECKED:MF_UNCHECKED));
				break;
				case	IDC_STAY_ON_TOP:
					if (StayOnTop==FALSE){
						tmp = HWND_TOPMOST;
						StayOnTop=TRUE;
					}
					else{
						tmp = HWND_NOTOPMOST;
						StayOnTop=FALSE;
					}
					GetWindowRect(dWnd, &rect);
					GetWindowRect(GetDesktopWindow(), &rectDT);
					SetWindowPos(dWnd, tmp
								,rectDT.right-(rect.right-rect.left)-10//rect.left
								,rectDT.bottom - (rect.bottom-rect.top)-20//rect.top,
								,rect.right-rect.left
								,rect.bottom-rect.top
								,SWP_SHOWWINDOW);
				return TRUE;
				case IDC_QUIT:
					DestroyWindow(dWnd);
				return TRUE;
			}
	}
	return FALSE+(int)lParam-(int)lParam;
}

//=====================================================================
BOOL CALLBACK ConfigDlgProc(HWND dWnd, WORD wMsg, WORD wParam, DWORD lParam)
{
	switch(wMsg)
	{

		case WM_INITDIALOG:
			sprintf (szLineout, "%u", Interval);
			SetDlgItemText(dWnd, TIME_INTERVAL_REQUESTED, szLineout);

			sprintf (szLineout, "%u", DelayAfterStart);
			SetDlgItemText(dWnd, IDC_DELAY_AFTER_START_BUTTON, szLineout);

			sprintf (szLineout, "%u", BufferSize);
			SetDlgItemText(dWnd, IDC_BUFFER_SIZE, szLineout);

			sprintf (szLineout, "%u", Auto_Stop_Time);
			SetDlgItemText(dWnd, IDC_AUTO_STOP_TIME, szLineout);


		return TRUE;

		case WM_CLOSE:
			EndDialog(dWnd, wParam );
		return TRUE;


		case WM_COMMAND:
			switch(wParam)
			{

				case	CONFIG_OK:
					GetDlgItemText(dWnd, TIME_INTERVAL_REQUESTED, szLineout, 5);
					if (strcmp(szLineout, ""))
						Interval = atoi(szLineout);
					if (Interval == 0){
						MessageBeep(MB_ICONASTERISK);
						PutMsg ("Interval is adjusted to 1000 [ms]");
						Interval = 1000;
					}
					GetDlgItemText(dWnd, USER_MESSAGE, szLineout, 30);
					if (strcmp(szLineout, ""))
						strcpy(LogMessage, szLineout);

					GetDlgItemText(dWnd, IDC_BUFFER_SIZE, szLineout, 8);
					if (strcmp(szLineout, ""))
						BufferSize = atoi(szLineout);
					if (BufferSize > MAXEVENT){
						MessageBeep(MB_ICONASTERISK);
						sprintf (szLineout, "Buffer size adjusted to %u entries", MAXEVENT);
						PutMsg (szLineout);
						BufferSize = MAXEVENT;
					}
					if (BufferSize == 0){
						MessageBeep(MB_ICONASTERISK);
						PutMsg ("Buffer Size is adjusted to 20");
						BufferSize = 20;
					}
					
					GetDlgItemText(dWnd, IDC_DELAY_AFTER_START, szLineout, 5);
					if (strcmp(szLineout, ""))
						DelayAfterStart = atoi(szLineout);


					GetDlgItemText(dWnd, IDC_AUTO_STOP_TIME, szLineout, 6);
					if (strcmp(szLineout, ""))
						Auto_Stop_Time = atoi(szLineout);

					
					sprintf (szLineout, "Config: Interval = %u, Buf Size = %u,"
						"Capture Time = %u sec,  ", 
								Interval, BufferSize, 
								(Interval * BufferSize)/1000);
					PutMsg (szLineout);

					sprintf (szLineout, "Config: Delay After Start = %u,  Auto Stop = %u Sec", 
								DelayAfterStart, Auto_Stop_Time);
					PutMsg (szLineout);

					KillTimer(hWnd, AutoCaptureTimer);
					AutoCaptureTimer = SetTimer(hWnd, 444, Interval, (TIMERPROC)AutoCaptureTimerProc);


					
					EndDialog(dWnd, wParam );
				break;
		
				case	CONFIG_CANCEL:
				case IDC_QUIT:
					EndDialog(dWnd, wParam );
				break;
			}
		return TRUE;
	}
	return FALSE+(int)lParam-(int)lParam;
}


//=====================================================================
void	SelectEventsInComboBox(int event0, int event1){
	SendMessage (Event0Wnd, CB_SETCURSEL, (WPARAM)event0, 0);
	SendMessage (Event1Wnd, CB_SETCURSEL, (WPARAM)event1, 0);
}

//=====================================================================
void InitMaskInComboBox(){
	int i;

	for (i=0;i<0x100;i++)
		sprintf(&szLineout[3*i], "%02X", i);
	
	InitComboBox(Event0MaskWnd, szLineout, 256*3, 3, szLineout);
	InitComboBox(Event1MaskWnd, szLineout, 256*3, 3, szLineout);
}

void InitEventIndexInComboBox(){
	int i;
	for (i=0;i<120;i++)
		sprintf(&szLineout[4*i], "%03u", i);
	InitComboBox(T0IndexWnd, szLineout, 120*4, 4, szLineout);
	InitComboBox(T1IndexWnd, szLineout, 120*4, 4, szLineout);

}

//=====================================================================
void InitEventsInComboBox(){

	if (Which_CPU == Pentium){
		InitComboBox(Event0Wnd, (char *) &Events0p55C,
						(EVENT_STRING_LENGTH+1)*NumberOfDBFilesP55c,
						EVENT_STRING_LENGTH+1,
						Events0p55C[0].str);
			
		InitComboBox(Event1Wnd, (char *) &Events1p55C,
						(EVENT_STRING_LENGTH+1)*NumberOfDBFilesP55c,
						EVENT_STRING_LENGTH+1,
						Events1p55C[0].str);
	}
	if (Which_CPU == PentiumPro){
		InitComboBox(Event0Wnd, (char *) &PentiumPro_events[0].str,
						(EVENT_STRING_LENGTH+2)*NumberOfDBFilesPPro,
						EVENT_STRING_LENGTH+2,
						PentiumPro_events[0].str);

		InitComboBox(Event1Wnd, (char *) &PentiumPro_events[0].str,
						(EVENT_STRING_LENGTH+2)*NumberOfDBFilesPPro,
						EVENT_STRING_LENGTH+2,
						PentiumPro_events[0].str);
	}
}

//==================================================
void	GetWindowsHandles (void)
{
	ListWnd 		= GetDlgItem(MainDlg, IDC_MESSAGES);

	Counter0Wnd 	= GetDlgItem(MainDlg, IDC_COUNTER0);
	Counter1Wnd 	= GetDlgItem(MainDlg, IDC_COUNTER1);

	TSCWnd 			= GetDlgItem(MainDlg, IDC_TSC);
	ElapsedTimeWnd	= GetDlgItem(MainDlg, IDC_ELAPSED_TIME);

	Event0Wnd 		= GetDlgItem(MainDlg, IDC_COUNTER0_EVENTS);
	Event1Wnd 		= GetDlgItem(MainDlg, IDC_COUNTER1_EVENTS);

	Event0MaskWnd 		= GetDlgItem(MainDlg, IDC_CNT0_REQ_MASK);
	Event1MaskWnd 		= GetDlgItem(MainDlg, IDC_CNT1_REQ_MASK);
		


	Cnt0_L012Wnd 		= GetDlgItem(MainDlg, IDC_CNT0_L012);
	Cnt0_L3Wnd 			= GetDlgItem(MainDlg, IDC_CNT0_L3);
	Cnt1_L012Wnd 		= GetDlgItem(MainDlg, IDC_CNT1_L012);
	Cnt1_L3Wnd 			= GetDlgItem(MainDlg, IDC_CNT1_L3);
	START_COUNTERS_Wnd 	= GetDlgItem(MainDlg, IDC_START_BUTTON);
	DelayedStartWnd		= GetDlgItem(MainDlg, IDC_START_DELAY);

	START_AUTO_CAPTURE_COUNTERS_Wnd	= GetDlgItem(MainDlg, IDC_ACCUMULATIVE_START_STOP);

	T0CodeWnd 		= GetDlgItem(MainDlg, IDC_CNT0_REQ_EVENT);
	T1CodeWnd 		= GetDlgItem(MainDlg, IDC_CNT1_REQ_EVENT);

	T0IndexWnd 		= GetDlgItem(MainDlg, IDC_EVENT0_INDEX);
	T1IndexWnd 		= GetDlgItem(MainDlg, IDC_EVENT1_INDEX);

	ControlPanelMenuH = GetMenu(MainDlg);
	
}



int iAdd = 0;

void	PutMsg (char *msg)
{
	int i=0;

	HDC hdc;        // HDC for Window

	if (InterActiveMode == FALSE)
		return;
			
	hdc = GetDC(ListWnd);

	iAdd = (int) SendMessage(ListWnd, LB_ADDSTRING, 0, (LPARAM)(LPCSTR) msg);
	if (iAdd >= 50)
			iAdd = (int) SendMessage(ListWnd, LB_DELETESTRING, 0, 0L);
	SendMessage(ListWnd, LB_SETTOPINDEX, iAdd - 1, 0L );

	ReleaseDC(ListWnd, hdc);
}

//---------------------------------------------------------------
 void InitComboBox(HWND hComboBox, char *Array,
				  int ArraySize, int ArrayValSize, char *selection)
{
	WORD numOfValues, valuePointer;
//	char	*ptr;

	 SendMessage (hComboBox, CB_RESETCONTENT, 0, 0);

	/* Do not redraw the items put into the combo box */
	SendMessage (hComboBox, WM_SETREDRAW, FALSE, 0L);

	/* Add the available selections for the combo box. Always adding
		to index 0, which will put the selection in the order received
		or sorted, depend on the type of the combo box */
	for (numOfValues=0,valuePointer=0;
		 numOfValues < (ArraySize/ArrayValSize);
		 numOfValues++, valuePointer += ArrayValSize)
		 SendMessage (hComboBox, CB_ADDSTRING, 0,
					(LONG)(LPSTR) Array+valuePointer);

	/* Now set the current selection in the edit field of the combo box */
	SendMessage(hComboBox, CB_SELECTSTRING, (WPARAM)SEARCH_FROM_BEGINNING,
						(LPARAM) selection);

	/* can redraw, now that all items are in */
	SendMessage (hComboBox, WM_SETREDRAW, TRUE, 0L);
}



