/***************************************************************
Subject to the terms and conditions set forth below, Intel hereby 
grants you a nonexclusive, nontransferable license, under its 
patents and copyrights on the example source code sequences listed 
below,  to use, reproduce and distribute such example source code 
sequences, in object code format, solely as part of your computer 
program(s) and solely in order to allow your computer program(s) 
to implement the multimedia instruction extensions contained in 
such sequences solely with respect to the Intel instruction set 
architecture.  No other license, express, implied, statutory, by 
estoppel or otherwise, to any other intellectual property rights 
is granted herein.

THE EXAMPLE SOURCE CODE SEQUENCES LISTED BELOW ARE  PROVIDED "AS IS" 
WITH NO WARRANTIES, EXPRESS, IMPLIED, STATUTORY OR OTHERWISE, AND INTEL 
SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF MERCHANTABILITY,  
NONINFRINGEMENT OR FITNESS FOR ANY PARTICULAR PURPOSE.

Any use or distribution of  example source code sequences listed below 
must  fully comply with all then current laws of the United States 
including, without limitation, rules and regulations of the 
United States Office of Export Administration and other applicable 
U.S. governmental agencies.
 
IN NO EVENT WILL INTEL BE LIABLE FOR ANY DAMAGES OF ANY KIND, INCLUDING 
DIRECT OR INDIRECT DAMAGES, LOSS OF DATA, LOST PROFITS, COST OF COVER OR 
SPECIAL, INCIDENTAL, CONSEQUENTIAL, DAMAGES ARISING FROM THE USE OF THE 
EXAMPLE SOURCE CODE SEQUENCES LISTED BELOW, HOWEVER CAUSED AND ON ANY 
THEORY OF LIABILITY.  THIS LIMITATION WILL APPLY EVEN IF INTEL OR ANY 
AUTHORIZED AGENT OF INTEL HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH 
DAMAGE.

Copyright c 1996 Intel Corporation 
***********************************************************************/
/**********************************************************************/

/* system header files */
#include <windows.h>
#include <stdio.h>
#include <time.h>
#include <dos.h>
#include <stdlib.h>

#include <fcntl.h>
#include <io.h>

#include "genericr.h"



/*  Global Variables  */
char szLineout	[400]; /* temp output string */
char szLineout1 [200];
HINSTANCE hInst;  /* current instance */
BOOL help_flag;

static char bufstr[256];
static char dlgstr[4096];
FARPROC DlgProc;
HWND asWnd, ListWnd;

char AutoShowFP=FALSE;
int ShowFPTimer;
#define ShowFpTimerId 3;

HWND	FLDZ_BUT_Wnd, FLDPI_BUT_Wnd, FLD1_BUT_Wnd, FP_VU_BUT_Wnd, FLD80_BUT_Wnd, But6_Wnd;
HWND	FINCSTP_BUT_Wnd, AUTO_VU_BUT_Wnd, FDECSTP_BUT_Wnd, FLD80_BUT_Wnd, FLD80_2_BUT_Wnd;
HWND	MMX_1_BUT_Wnd, MMX_2_BUT_Wnd, FSTP_BUT_Wnd, EMMS_BUT_Wnd;

#define	FLDZ_BUT	501
#define	FLDPI_BUT	502
#define	FLD1_BUT	503
#define	FP_VU_BUT	504
#define	FLD80_BUT	505
#define	FINIT_BUT	506
#define	FINCSTP_BUT	507
#define	AUTO_VU_BUT	508
#define	FDECSTP_BUT	509
#define	FLD80_2_BUT	510
#define	MMX_1_BUT	511
#define	MMX_2_BUT	512
#define	FSTP_BUT	513
#define	EMMS_BUT	514

int	 	MainWinWidth = 480;
int 	MainWinHight = 540;

int SpyFlag=TRUE;
WORD	App_cs, App_ip;

RECT cntarea;				/* window region containing updated data*/

	 char    window_style;

	time_t timer;
	struct tm *tblock;
HFONT hfont, hfontOld;
int MapModePrevious, iPtSize = 18;
PSTR pszFace = "Courier";

#include <pshpack1.h>
union	x{
	long double	er;
	struct	MMi{
		WORD	word[4];
		WORD	exponent;
	}mm;
}fp80;

struct	fpstruct	{
	WORD	cw;
	WORD	res1;
	WORD	sw;
	WORD	res3;
	WORD	tw;
	WORD	res2;
	WORD	env1[4];
	WORD	env2[4];
	union{
		long double	r;
		WORD	ri[5];
		}reg[8];
}fp;
#include <poppack.h>




/**********************************************************************/

BOOL InitApplication(HINSTANCE hInstance);
BOOL InitInstance(HINSTANCE hInstance, LPSTR lpCmdLine, int nCmdShow);
void help_box(HWND hWnd);
void printFP(struct fpstruct *fp, char *buf);
void	PutMsg (HWND hWnd, char *msg, char *msg1);

//****************************************************************************/
long FAR PASCAL	MainWndProc(HWND hWnd, UINT message,
						WPARAM wParam, LPARAM lParam)
{
  RECT rTemp;     // Client are needed by DrawText()
  HDC hdc;        // HDC for Window
  PAINTSTRUCT ps; // Paint Struct for BeginPaint call

  int i;

long double fp1;

  switch (message) {
  case WM_CREATE: // Initialize Global vars
	_asm	finit
	_asm	fldl2t
	_asm	fldl2t
	_asm	fldl2t
	_asm	fldl2t
	_asm	fldl2t
	_asm	fldl2t


	_asm	fldl2t
	_asm	fldl2t
	_asm	finit
		ListWnd = CreateWindow(
					 "LISTBOX",	 "",
					 /*WS_OVERLAPPEDWINDOW |*/WS_CHILDWINDOW | WS_BORDER | WS_VISIBLE|
						 WS_VSCROLL,
					2, 50, //x,y
					MainWinWidth-12,
					MainWinHight-98,
					hWnd, (HMENU)554,	 hInst, NULL);

		ShowWindow(ListWnd, SW_SHOW);
		UpdateWindow(ListWnd);

		But6_Wnd = CreateWindow(
					 "BUTTON",	 "FINIT",
					 WS_CHILDWINDOW | WS_VISIBLE,
					 55,0, //x,y
					 50, 20, //W,H
					 hWnd, (HMENU)FINIT_BUT, hInst, NULL);
		ShowWindow(But6_Wnd, SW_SHOW);
		UpdateWindow(But6_Wnd);

		EMMS_BUT_Wnd = CreateWindow(
					 "BUTTON",	 "EMMS",
					 WS_CHILDWINDOW | WS_VISIBLE,
					 55,22, //x,y
					 50, 20, //W,H
					 hWnd, (HMENU)EMMS_BUT, hInst, NULL);
		ShowWindow(EMMS_BUT_Wnd, SW_SHOW);
		UpdateWindow(EMMS_BUT_Wnd);

		MMX_1_BUT_Wnd = CreateWindow(
					 "BUTTON",	 "MMX 1",
					 WS_CHILDWINDOW | WS_VISIBLE,
					 0,0, //x,y
					 52, 20, //W,H
					 hWnd, (HMENU)MMX_1_BUT, hInst, NULL);
		ShowWindow(MMX_1_BUT_Wnd, SW_SHOW);
		UpdateWindow(MMX_1_BUT_Wnd);

		MMX_2_BUT_Wnd = CreateWindow(
					 "BUTTON",	 "MMX 2",
					 WS_CHILDWINDOW | WS_VISIBLE,
					 0,22, //x,y
					 52, 20, //W,H
					 hWnd, (HMENU)MMX_2_BUT, hInst, NULL);
		ShowWindow(MMX_2_BUT_Wnd, SW_SHOW);
		UpdateWindow(MMX_2_BUT_Wnd);

		FLDZ_BUT_Wnd = CreateWindow(
					 "BUTTON",	 "FldZ",
					 WS_CHILDWINDOW | WS_VISIBLE,
					 110,22, //x,y
					 42, 20, //W,H
					 hWnd, (HMENU)FLDZ_BUT, hInst, NULL);
		ShowWindow(FLDZ_BUT_Wnd, SW_SHOW);
		UpdateWindow(FLDZ_BUT_Wnd);

		FSTP_BUT_Wnd = CreateWindow(
					 "BUTTON",	 "Fstp",
					 WS_CHILDWINDOW | WS_VISIBLE,
					 110,0, //x,y
					 42, 20, //W,H
					 hWnd, (HMENU)FSTP_BUT, hInst, NULL);
		ShowWindow(FSTP_BUT_Wnd, SW_SHOW);
		UpdateWindow(FSTP_BUT_Wnd);

		FLDPI_BUT_Wnd = CreateWindow(
					 "BUTTON",	 "Fld PI",
					 WS_CHILDWINDOW | WS_VISIBLE,
					 154,22, //x,y
					 47, 20, //W,H
					 hWnd, (HMENU)FLDPI_BUT, hInst, NULL);
		ShowWindow(FLDPI_BUT_Wnd, SW_SHOW);
		UpdateWindow(FLDPI_BUT_Wnd);

		FLD1_BUT_Wnd = CreateWindow(
					 "BUTTON",	 "Fld 1",
					 WS_CHILDWINDOW | WS_VISIBLE,
					 154,0, //x,y
					 47, 20, //W,H
					 hWnd, (HMENU)FLD1_BUT, hInst, NULL);
		ShowWindow(FLD1_BUT_Wnd, SW_SHOW);
		UpdateWindow(FLD1_BUT_Wnd);

		FLD80_BUT_Wnd = CreateWindow(
					 "BUTTON",	 "Fld80",
					 WS_CHILDWINDOW | WS_VISIBLE,
					 210,0, //x,y
					 45, 20, //W,H
					 hWnd, (HMENU)FLD80_BUT, hInst, NULL);
		ShowWindow(FLD80_BUT_Wnd, SW_SHOW);
		UpdateWindow(FLD80_BUT_Wnd);

		FLD80_2_BUT_Wnd = CreateWindow(
					 "BUTTON",	 "Fld80'",
					 WS_CHILDWINDOW | WS_VISIBLE,
					 210,22, //x,y
					 45, 20, //W,H
					 hWnd, (HMENU)FLD80_2_BUT, hInst, NULL);
		ShowWindow(FLD80_2_BUT_Wnd, SW_SHOW);
		UpdateWindow(FLD80_2_BUT_Wnd);

		FINCSTP_BUT_Wnd = CreateWindow(
					 "BUTTON",	 "FincSTP",
					 WS_CHILDWINDOW | WS_VISIBLE,
					 260,0, //x,y
					 73, 20, //W,H
					 hWnd, (HMENU)FINCSTP_BUT, hInst, NULL);
		ShowWindow(FINCSTP_BUT_Wnd, SW_SHOW);
		UpdateWindow(FINCSTP_BUT_Wnd);

		FDECSTP_BUT_Wnd = CreateWindow(
					 "BUTTON",	 "FdecSTP",
					 WS_CHILDWINDOW | WS_VISIBLE,
					 260,22, //x,y
					 73, 20, //W,H
					 hWnd, (HMENU)FDECSTP_BUT, hInst, NULL);
		ShowWindow(FDECSTP_BUT_Wnd, SW_SHOW);
		UpdateWindow(FDECSTP_BUT_Wnd);


		FP_VU_BUT_Wnd = CreateWindow(
					 "BUTTON",	 "VU FP",
					 WS_CHILDWINDOW | WS_VISIBLE,
					 360,0, //x,y
					 78, 20, //W,H
					 hWnd, (HMENU)FP_VU_BUT, hInst, NULL);
		ShowWindow(FP_VU_BUT_Wnd, SW_SHOW);
		UpdateWindow(FP_VU_BUT_Wnd);

		
		AUTO_VU_BUT_Wnd = CreateWindow(
					 "BUTTON",	 "AUTO VU",
					 WS_CHILDWINDOW | WS_VISIBLE,
					 360,22, //x,y
					 78, 20, //W,H
					 hWnd, (HMENU)AUTO_VU_BUT, hInst, NULL);
		ShowWindow(AUTO_VU_BUT_Wnd, SW_SHOW);
		UpdateWindow(AUTO_VU_BUT_Wnd);


	 return (TRUE);

  case WM_PAINT:
		hdc=BeginPaint(hWnd,&ps);
		GetClientRect( hWnd, &rTemp );
		hfontOld = SelectObject(hdc, hfont);
		DrawText( hdc, szLineout, strlen(szLineout1), &rTemp,
				DT_WORDBREAK |DT_TABSTOP | DT_EXPANDTABS | 0x0600); // tab=6
		EndPaint(hWnd,&ps);
 break;

	case WM_COMMAND:  // message: command from application menu
		switch(wParam)
		{
			case	CM_CLEAR:
				SendMessage(ListWnd, LB_RESETCONTENT, (WPARAM)0, (LPARAM)NULL);
			break;

			case	FSTP_BUT:
				_asm	lea		ebx, fp1
				_asm	fstp	fp80
				_asm{
					lea		ebx, fp
					fnsave  [ebx]
					frstor	[ebx]
				}
				printFP(&fp, szLineout1);
			break;

			case	FLDZ_BUT:

				_asm	fldz
				_asm{
					lea		ebx, fp
					fnsave  [ebx]
					frstor	[ebx]
				}
				printFP(&fp, szLineout1);
			break;

			case	FLDPI_BUT:
				_asm	fldpi
				_asm{
					lea		ebx, fp
					fnsave  [ebx]
					frstor	[ebx]
				}
				printFP(&fp, szLineout1);
			break;

			case	FLD1_BUT:
				_asm	fld1
				_asm{
					lea		ebx, fp
					fnsave  [ebx]
					frstor	[ebx]
				}
				printFP(&fp, szLineout1);
			break;

			case	FP_VU_BUT:
				_asm{
					lea		ebx, fp
					fnsave  [ebx]
					frstor	[ebx]
				}
				printFP(&fp, szLineout1);
			break;

			case	FLD80_BUT:
				fp80.mm.word[0]=0x1234;
				fp80.mm.word[1]=0x1234;
				fp80.mm.word[2]=0x1234;
				fp80.mm.word[3]=0x1234;
				fp80.mm.exponent=0x5555;
				_asm	fld	fp80
				_asm{
					lea		ebx, fp
					fnsave  [ebx]
					frstor	[ebx]
				}
				printFP(&fp, szLineout1);
			break;

			case	FLD80_2_BUT:
				fp80.mm.word[0]=0x5555;
				fp80.mm.word[1]=0xaaaa;
				fp80.mm.word[2]=0x5555;
				fp80.mm.word[3]=0xaaaa;
				fp80.mm.exponent=0x9999;
				_asm	fld	fp80
				_asm{
					lea		ebx, fp
					fnsave  [ebx]
					frstor	[ebx]
				}
				printFP(&fp, szLineout1);
			break;

			case	MMX_1_BUT:
				_asm{
					lea		ebx, fp
					fstenv	[ebx]
				}
				fp.sw = fp.sw & 0xc7ff;
				fp.tw = 0;
				_asm{
					lea		ebx, fp
					fldenv	[ebx]
					fnsave  [ebx]
				}
				fp.reg[5].ri[4]=0xffff;
				fp.reg[5].ri[3]=0x4444;
				fp.reg[5].ri[2]=0x3333;
				fp.reg[5].ri[1]=0x1111;
				fp.reg[5].ri[0]=0x0000;
				_asm{
					frstor	[ebx]
				}
				_asm{
					lea		ebx, fp
					fnsave  [ebx]
					frstor	[ebx]
				}
				printFP(&fp, szLineout1);

			break;

			case	MMX_2_BUT:
				_asm{  // let the fpu rearange the stack to physical
					lea		ebx, fp
					fstenv	[ebx]
				}
				fp.sw = fp.sw & 0xc7ff;
				fp.tw = 0;
				_asm{
					lea		ebx, fp
					fldenv	[ebx]		// now TOS=0, Tag=valid
					fnsave  [ebx]
				}
				fp.reg[2].ri[4]=0xffff;
				fp.reg[2].ri[3]=0x9999;
				fp.reg[2].ri[2]=0x9999;
				fp.reg[2].ri[1]=0x9999;
				fp.reg[2].ri[0]=0x9999;
				_asm{
					frstor	[ebx]
				}
				_asm{
					lea		ebx, fp
					fnsave  [ebx]
					frstor	[ebx]
				}
				printFP(&fp, szLineout1);

			break;

			case	EMMS_BUT:		// emms
				_asm{  // let the fpu rearange the stack to physical
					lea		ebx, fp
					fstenv	[ebx]
				}
				fp.sw = fp.sw & 0xc7ff;
				fp.tw = 0xffff;
				_asm{
					lea		ebx, fp
					fldenv	[ebx]		// now TOS=0, Tag=valid
				}
				_asm{
					lea		ebx, fp
					fnsave  [ebx]
					frstor	[ebx]
				}
				printFP(&fp, szLineout1);

			break;


			case	FINIT_BUT:
				_asm	fninit
				_asm{
					lea		ebx, fp
					fnsave  [ebx]
					frstor	[ebx]
				}
				printFP(&fp, szLineout1);
			break;

			case	FINCSTP_BUT:
				_asm FincSTP
				_asm{
					lea		ebx, fp
					fnsave  [ebx]
					frstor	[ebx]
				}
				printFP(&fp, szLineout1);
			break;

			case	FDECSTP_BUT:
				_asm FdecSTP
				_asm{
					lea		ebx, fp
					fnsave  [ebx]
					frstor	[ebx]
				}
				printFP(&fp, szLineout1);
			break;

			case	AUTO_VU_BUT:
				if (AutoShowFP==FALSE)
				{
					ShowFPTimer = SetTimer(hWnd, 4,	5000, NULL);
					AutoShowFP=TRUE;
					SetWindowText(AUTO_VU_BUT_Wnd, "Stop Auto");
				}
				else{
					KillTimer (hWnd, ShowFPTimer);
					AutoShowFP=FALSE;
					SetWindowText(AUTO_VU_BUT_Wnd, "Auto VU");
				}
			break;

			case    CM_FORGET_EMMS:

				_asm{
					lea		ebx, fp
					fstenv	[ebx]
				}
				fp.tw = 0;	// all valid
				_asm{
					lea		ebx, fp
					fldenv	[ebx]
					fsave	[ebx]
					frstor	[ebx]
				}
				i = (fp.sw>>11) & 7;
				sprintf(szLineout1,
						"\tCW=%04X, TW=%04X, SW=%04X (TOS=%d)"
						"\n\n"
						,fp.cw,fp.tw,fp.sw,(fp.sw>>11) & 7);
				InvalidateRect(hWnd, NULL, TRUE);
				SendMessage (hWnd, WM_PAINT, 0, 0);
			break;

			case    CM_ABOUT:
					MessageBox(hWnd,"October 1996\n              version 1.0",
								"PlayAround with IA Regs",MB_OK);
			break;
			case    CM_HELP:
					help_box(hWnd);			/* display help dialog box */
			break;

			case    CM_EXIT:
					DestroyWindow(hWnd);
			break;
			default:
			break;
	 }	// wm_command

	break;
	case WM_TIMER:
			_asm{
				lea		ebx, fp
				fnsave  [ebx]
				frstor	[ebx]
			}
			printFP(&fp, szLineout1);
	break;
	case WM_QUIT:
	case WM_DESTROY:  // message: window being destroyed
		PostQuitMessage(0);
	break;

	default:      // Passes it on if unproccessed
	return (DefWindowProc(hWnd, message, wParam, lParam));
  }
	return (long)NULL;
}

/**************************************************************/
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
			  LPSTR lpCmdLine, int nCmdShow)
{
  MSG msg;      // message

  if (!hPrevInstance) // Other instances of app running?
  {
	if (!InitApplication(hInstance))  // Initialize shared things
		 return (FALSE); // Exits if unable to initialize
  }
//  else
//	return (NULL); 	// don't allow multiple instances of this program


  /* Perform initializations that apply to a specific instance */

  if (!InitInstance(hInstance, lpCmdLine, nCmdShow))
	 return (FALSE);

  /* Acquire and dispatch messages until a WM_QUIT message is received. */

  while (GetMessage(&msg, // message structure
	 (HWND)NULL, // handle of window receiving the message
	 (UINT)NULL, // lowest message to examine
	 (UINT)NULL))  // highest message to examine
  {
  TranslateMessage(&msg); // Translates virtual key codes
  DispatchMessage(&msg);  // Dispatches message to window
  }
  return (msg.wParam);  // Returns the value from PostQuitMessage
}

int iAdd = 0;

void	PutMsg (HWND hWnd, char *msg, char *msg1)
{
	int ln;
	int i=0;
	char tmp;

	  HDC hdc;        // HDC for Window
		hdc = GetDC(hWnd);

		iAdd = (int) SendMessage(hWnd, LB_ADDSTRING, 0, (LPARAM)(LPCSTR) msg);
		if (iAdd >= 50)
			iAdd = (int) SendMessage(hWnd, LB_DELETESTRING, 0, 0L);
		SendMessage(hWnd, LB_SETTOPINDEX, iAdd - 1, 0L );

		if (msg1!=NULL){
				ln = strlen(msg1);
				while (ln>81){
					tmp=msg1[i+81];
					msg1[i+81] = 0;
					iAdd = (int) SendMessage(hWnd, LB_ADDSTRING, 0, (LPARAM)(LPCSTR) &msg1[i]);
					if (iAdd >= 50)
						iAdd = (int) SendMessage(hWnd, LB_DELETESTRING, 0, 0L);
					SendMessage(hWnd, LB_SETTOPINDEX, iAdd - 1, 0L );
					msg1[i+81] = tmp;
					i = i+81;
					ln = ln -81;
				}
				iAdd = (int) SendMessage(hWnd, LB_ADDSTRING, 0, (LPARAM)(LPCSTR) &msg1[i]);
				if (iAdd >= 50)
					iAdd = (int) SendMessage(hWnd, LB_DELETESTRING, 0, 0L);
				SendMessage(hWnd, LB_SETTOPINDEX, iAdd - 1, 0L );
		}
		ReleaseDC(hWnd, hdc);

}

BOOL InitApplication(HINSTANCE hInstance)
{
  WNDCLASS  wc;

  // Fill in window class structure with parameters that describe the
  // main window.

  wc.style = CS_HREDRAW | CS_VREDRAW; // Class style(s).
  /* Function to retrieve messages for this class */
  wc.lpfnWndProc = MainWndProc;
  wc.cbClsExtra = 0;  // No per-class extra data.
  wc.cbWndExtra = 0;  // No per-window extra data.
  wc.hInstance = hInstance; // Application that owns the class.
  wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
  wc.hCursor = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = GetStockObject(WHITE_BRUSH);
  wc.lpszMenuName = "GENERICMENU";  // Name of menu resource in .RC file.
  wc.lpszClassName = "Generic"; // Name used in call to CreateWindow.

  /* Register the window class and return success/failure code. */

  return (RegisterClass(&wc));

}

/************************************************************************/
BOOL InitInstance(HINSTANCE hInstance, LPSTR lpCmdLine, int nCmdShow)
{
  HWND  hWnd; // Main window handle.
  LPSTR	tempcmd;

  /* Save the instance handle in static variable, which will be used in  */
  /* many subsequence calls from this application to Windows.            */

  hInst = hInstance;
  tempcmd= lpCmdLine; /* save command line pointer */
  help_flag= FALSE;

  /* Create a main window for this application instance.  */
  hWnd = CreateWindow(
	 "Generic",                 // See RegisterClass() call.
	 "PlayAround with IA Regs",  // Text for window title bar.
	 WS_OVERLAPPEDWINDOW,
	 50, //CW_USEDEFAULT,         // Default horizontal position.
	 20, //CW_USEDEFAULT,          // Default vertical position.
	 MainWinWidth,							// width.
	 MainWinHight,							// width.
	 NULL,                  // Overlapped windows have no parent.
	 NULL,                  // Use the window class menu.
	 hInstance,              // This instance owns this window.
	 NULL                   // Pointer not needed.
  );


  ShowWindow(hWnd, SW_SHOW ); // Show the window


  UpdateWindow(hWnd);     // Sends WM_PAINT message


 InvalidateRect(hWnd, NULL, TRUE);

  return (TRUE);        // Returns the value from PostQuitMessage
}

//------------------------------ Help --------------------------
void help_box(HWND hWnd)
{
		MessageBox(hWnd,"No help available. Use IA PRM or The Complete Book of MMX technology","Help",
					MB_OK | MB_ICONINFORMATION);
}



//------------------------   printFP
void printFP(struct fpstruct *fp, char *buf){
int i,j;
char	msg2	[100];
WORD	tg;

	i = (fp->sw>>11) & 7; //TOS
	sprintf(msg2, " ---->---> CW=%04X,   TW=%04X,   SW=%04X ----->>TOS=%d"
				  ,fp->cw,fp->tw,fp->sw,(fp->sw>>11) & 7);
	PutMsg (ListWnd, msg2, NULL);

	for (j=0;j<8;j++){
		tg = fp->tw;
		tg = (tg>>(i*2))&3;
		sprintf (msg2,
					"%s ST(%d)=FP/MM(%d)= %04X  %04X%04X %04X%04X"
					,tg==3 ? "+":"-"
					, j, i
					,fp->reg[j].ri[4]
					,fp->reg[j].ri[3]
					,fp->reg[j].ri[2]
					,fp->reg[j].ri[1]
					,fp->reg[j].ri[0]
					);
		PutMsg (ListWnd, msg2, NULL);
		i=(i+1)%8;
	}
}

