;/*
;*    INTEL CORPORATION PROPRIETARY INFORMATION 
;*
;*    This software is supplied under the terms of a license
;*    agreement or nondisclosure agreement with Intel Corporation 
;*    and may not be copied or disclosed except in accordance with 
;*    the terms of that agreement.
;*    Copyright (c) 1991,1992,1993  Intel Corporation. 
;*
;*/

IFDEF APP_32BIT
  .486P
  .Model FLAT, C
ELSE
  .Model Medium, C   
ENDIF

include iammx.inc

EXTERNDEF	C CompareResults:PROC

.Data
IFDEF APP_32BIT
	ALIGN 4
    qwTmp1	dd	2 dup(0)
    qwTmp2	dd	2 dup(0)
    qwTmp3	dd	2 dup(0)
    dwTmp	dd	1 dup(0)
ELSE
    qwTmp1	dw	4 dup(0)
    qwTmp2	dw	4 dup(0)
    qwTmp3	dw	4 dup(0)
    dwTmp	dw	2 dup(0)
ENDIF

DisplayResults Macro inst, ExpectedResultH, ExpectedResultL, GotH, GotL
Local	Instruction
	push	MMWORD PTR ExpectedResultL
	push	MMWORD PTR ExpectedResultH
	push	MMWORD PTR GotL
	push	MMWORD PTR GotH
	
IFDEF APP_32BIT
	lea		eax, Instruction
	push	eax
	call	CompareResults
	add		esp, 20
ELSE
	lea		ax, Instruction
	push	ds
	push	ax
	call	CompareResults
	add		sp, 20
ENDIF

.Data
	Instruction	db 	"&inst" , 0
.Code
EndM		; DisplayResults

T1	Macro inst, xh, xl, yh, yl, rh, rl
.Code
	mov		MMWORD PTR qwTmp1, xl
	mov		MMWORD PTR qwTmp1[4], xh
	mov		MMWORD PTR qwTmp2, yl
	mov		MMWORD PTR qwTmp2[4], yh
	mov		MMWORD PTR qwTmp3, 0
	mov		MMWORD PTR qwTmp3[4], 0
	movq	MM1, qwTmp2
	inst	MM1, qwTmp1
	movq	qwTmp3, MM1
	
	DisplayResults inst, rh, rl, qwTmp3[4], qwTmp3
EndM

T3 Macro inst, xh, xl, ShiftCount, rh, rl
	T1	inst, 0, ShiftCount, xh, xl, rh, rl

	mov		MMWORD PTR qwTmp1, xl
	mov		MMWORD PTR qwTmp1[4], xh
	mov		MMWORD PTR qwTmp3, 0
	mov		MMWORD PTR qwTmp3[4], 0
	movq	MM1, qwTmp1
	inst	MM1, ShiftCount
	movq	qwTmp3, MM1
	DisplayResults inst, rh, rl, qwTmp3[4], qwTmp3
EndM


T2	Macro mmReg
.Code
	mov		MMWORD PTR qwTmp1, 05a5a5a5ah
	mov		MMWORD PTR qwTmp1[4], 05a5a5a5ah
	movq	mmReg, qwTmp1
	pxor	mmReg, mmReg
	movq	qwTmp1, mmReg
	DisplayResults mmReg, 0, 0, qwTmp1[4], qwTmp1
EndM


.Code
RunIAMMxTest1	Proc C Public
	emms

	mov		MMWORD PTR qwTmp1, 012345678h
	mov		MMWORD PTR qwTmp1[4], 023456789h
	movq	mm0, qwTmp1
	movq	mm1, qwTmp1
	movq	mm2, qwTmp1
	movq	mm3, qwTmp1
	movq	mm4, qwTmp1
	movq	mm5, qwTmp1
	movq	mm6, qwTmp1
	movq	mm7, qwTmp1


	; Use all registers for source and destination..
	T2 MM0
	T2 MM1
	T2 MM2
	T2 MM3
	T2 MM4
	T2 MM5
	T2 MM6
	T2 MM7

	; addx
	T1 paddb   ,0807fb417h,0f3128575h,0ff7f21a2h,0e5459173h,07ffed5b9h,0d85716e8h
	T1 paddsb  ,0807fb417h,0f3128575h,0ff7f21a2h,0e5459173h,0807fd5b9h,0d857807fh
	T1 paddw   ,0237a9a31h,0f3477f51h,04ab0bc19h,0801e280eh,06e2a564ah,07365a75fh
	T1 paddsw  ,0237a9a31h,0f3477f51h,04ab0bc19h,0801e280eh,06e2a8000h,080007fffh
	T1 paddw   ,08000f301h,0f31e2301h,0134b7fffh,06501b735h,0934b7300h,0581fda36h
	T1 paddsw  ,08000f301h,0f31e2301h,0134b7fffh,06501b735h,0934b7300h,0581fda36h
	T1 paddusb ,0128023d1h,0f1f33273h,0d17f1712h,080b2d165h,0e3ff3ae3h,0ffffffd8h
	T1 paddusw ,080171749h,0f31583b1h,0831bac06h,00e47751ah,0ffffc34fh,0fffff8cbh
	T1 paddd   ,0237a9a31h,0f3477f51h,04ab0bc19h,0801e280eh,06e2b564ah,07365a75fh
	T1 paddd   ,08000f301h,0f31e2301h,0134b7fffh,06501b735h,0934c7300h,0581fda36h
																				
	; xcmp 
	T1 pcmpeqb ,05585bc7fh,03c5c8000h,01257e580h,03c99ff4ah,000000000h,0ff000000h
	T1 pcmpgtb ,01257e580h,03c99ff4ah,05585bc7fh,03c5c8000h,0ff0000ffh,000ff0000h
	T1 pcmpeqw ,085bc4315h,09413079ah,012076719h,0ab07079ah,000000000h,00000ffffh
	T1 pcmpgtw ,012076719h,0ab07079ah,085bc4315h,09413079ah,000000000h,000000000h
	T1 pcmpeqd ,085bc4315h,09413079ah,012076719h,09413079ah,000000000h,0ffffffffh
	T1 pcmpgtd ,082076719h,09b07079ah,015bc4315h,08413079ah,0ffffffffh,000000000h
																				
	; xmul 																		
	T1 pmulhw  ,08170217fh,012340e08h,000800080h,000800080h,0ffc00010h,000090007h
	T1 pmullw  ,03785bcd0h,07faef351h,09a3e8a43h,045811274h,074368a70h,03caef2b4h
	T1 pmaddwd ,03785bcd0h,071c771c7h,09a3e8a43h,080000400h,008d4fea6h,0C8E39C00h

	;/* pack, unpack,  sigma */
	T1 packsswb ,0009a0037h,0fff5f372h,08000831eh,000ff1237h,07f37f580h,080807f7fh
	T1 packuswb ,0009a0037h,00175f372h,08000831eh,000ff1237h,09a37ff00h,00000ffffh
	T1 packssdw ,000000037h,00175f372h,08000831eh,000ff1237h,000377fffh,080007fffh
    T1 punpcklbw,000000000h,011335577h,000000000h,022446688h,011223344h,055667788h
    T1 punpcklwd,000000000h,055556666h,000000000h,0aaaabbbbh,05555aaaah,06666bbbbh
    T1 punpckldq,000000000h,055556666h,000000000h,0aaaabbbbh,055556666h,0aaaabbbbh
    T1 punpckhbw,011335577h,000000000h,022446688h,000000000h,011223344h,055667788h
    T1 punpckhwd,055556666h,000000000h,0aaaabbbbh,000000000h,05555aaaah,06666bbbbh
    T1 punpckhdq,055556666h,000000000h,0aaaabbbbh,000000000h,055556666h,0aaaabbbbh
	
	;/*  Shifts */
	T3 psraw,	0ff00aa55h, 0aa095574h, 0,  0ff00aa55h, 0aa095574h
	T3 psraw,	0ff00aa55h,	0aa095574h,	1,	0ff80d52ah,	0d5042abah
	T3 psraw,	0ff00aa55h,	0aa095574h,	9,	0ffffffd5h,	0ffd5002ah
	T3 psraw,	0ff00aa55h,	0aa095574h,	15,	0ffffffffh,	0ffff0000h
	T3 psraw,	0ff00aa55h,	0aa095574h,	16,	0ffffffffh,	0ffff0000h
	T3 psraw,	0ff00aa55h,	0aa095574h,	37,	0ffffffffh,	0ffff0000h
	T3 psllw,	019ffb500h,	009aa7455h,	0,	019ffb500h,	009aa7455h
	T3 psllw,	019ffb500h,	009aa7455h,	1,	033fe6a00h,	01354e8aah
	T3 psllw,	019ffb500h,	009aa7455h,	9,	0fe000000h,	05400aa00h
	T3 psllw,	019ffb500h,	009aa7455h,	15,	080000000h,	000008000h
	T3 psllw,	019ffb500h,	009aa7455h,	16,	000000000h,	000000000h
	T3 psllw,	019ffb500h,	009aa7455h,	37,	000000000h,	000000000h
	T3 psrlw,	0ff00aa55h,	0aa095574h,	0,	0ff00aa55h,	0aa095574h
	T3 psrlw,	0ff00aa55h,	0aa095574h,	1,	07f80552ah,	055042abah
	T3 psrlw,	0ff00aa55h,	0aa095574h,	9,	0007f0055h,	00055002ah
	T3 psrlw,	0ff00aa55h,	0aa095574h,	15,	000010001h,	000010000h
	T3 psrlw,	0ff00aa55h,	0aa095574h,	16,	000000000h,	000000000h
	T3 psrlw,	0ff00aa55h,	0aa095574h,	37,	000000000h,	000000000h
	T3 psrad,	0ff00aa55h,	0aa095574h,	0,	0ff00aa55h,	0aa095574h
	T3 psrad,	0ff00aa55h,	0aa095574h,	1,	0ff80552ah,	0d504aabah
	T3 psrad,	0ff00aa55h,	0aa095574h,	9,	0ffff8055h,	0ffd504aah
	T3 psrad,	0ff00aa55h,	0aa095574h,	15,	0fffffe01h,	0ffff5412h
	T3 psrad,	0ff00aa55h,	0aa095574h,	16,	0ffffff00h,	0ffffaa09h
	T3 psrad,	0ff00aa55h,	00a095574h,	37,	0ffffffffh,	000000000h
	T3 pslld,	019ffb500h,	009aa7455h,	0,	019ffb500h,	009aa7455h
	T3 pslld,	019ffb500h,	009aa7455h,	1,	033ff6a00h,	01354e8aah
	T3 pslld,	019ffb500h,	009aa7455h,	9,	0ff6a0000h,	054e8aa00h
	T3 pslld,	019ffb500h,	009aa7455h,	15,	0da800000h,	03a2a8000h
	T3 pslld,	019ffb500h,	009aa7455h,	16,	0b5000000h,	074550000h
	T3 pslld,	019ffb500h,	009aa7455h,	37,	000000000h,	000000000h
	T3 psrld,	0ff00aa55h,	0aa095574h,	0,	0ff00aa55h,	0aa095574h
	T3 psrld,	0ff00aa55h,	0aa095574h,	1,	07f80552ah,	05504aabah
	T3 psrld,	0ff00aa55h,	0aa095574h,	9,	0007f8055h,	0005504aah
	T3 psrld,	0ff00aa55h,	0aa095574h,	15,	00001fe01h,	000015412h
	T3 psrld,	0ff00aa55h,	0aa095574h,	16,	00000ff00h,	00000aa09h
	T3 psrld,	0ff00aa55h,	0aa095574h,	37,	000000000h,	000000000h


	;/* subrp, subrup */
	T1 psubsb  ,0efe54e3fh,	0e1478219h,	0c7f73472h,	012f37181h,	0d812e633h,	031ac7f80h
	T1 psubb   ,0efe54e3fh,	0e1478219h,	0c7f73472h,	012f37181h,	0d812e633h,	031acef68h
	T1 psubsw  ,0e1804756h,	082c1197eh,	0123af307h,	0713b813ah,	030baabb1h,	07fff8000h
	T1 psubw   ,0e1804756h,	082c1197eh,	0123af307h,	0713b813ah,	030baabb1h,	0ee7a67bch
	T1 psubd   ,0e1804756h,	082c1197eh,	0123af307h,	0713b813ah,	030baabb1h,	0ee7a67bch
	T1 psubsw  ,0ef39e510h,	04ea63f07h,	0c72af714h,	0340f72bch,	0d7f11204h,	0e56933b5h
	T1 psubw   ,0ef39e510h,	04ea63f07h,	0c72af714h,	0340f72bch,	0d7f11204h,	0e56933b5h
	T1 psubusb ,0efe54e3fh,	0e1478219h,	0c7f73472h,	012f37181h,	000120033h,	000ac0068h
	T1 psubusw ,0e1804756h,	082c1197eh,	0123af307h,	0713b813ah,	00000abb1h,	0000067bch
	T1 psubusw ,0ef39e510h,	04ea63f07h,	0c72af714h,	0340f72bch,	000001204h,	0000033b5h
	T1 por     ,0c72af714h,	0340f72bch,	0ef39e510h,	04ea63f07h,	0ef3bf714h,	07eaf7fbfh
	T1 por     ,001020304h,	005060708h,	010203040h,	050607080h,	011223344h,	055667788h
	T1 pand    ,001020304h,	005060708h,	010203040h,	050607080h,	000000000h,	000000000h
	T1 pand    ,001020304h,	005060708h,	011223344h,	050607080h,	001020304h,	000000000h
	T1 pandn   ,0fefdfcfbh,	0faf9f8f7h,	010203040h,	050607080h,	0eeddccbbh,	0aa998877h
	T1 pandn   ,0fefdfcfbh,	0faf9f8f7h,	011223344h,	050607080h,	0eeddccbbh,	0aa998877h
	T3 psllq   ,0fefdfcfbh,	0faf9f8f7h,	4,	0efdfcfbfh,	0af9f8f70h
	T3 psrlq   ,0efdfcfbfh,	0af9f8f70h,	4,	00efdfcfbh,	0faf9f8f7h


IFDEF APP_32BIT
	mov		dwTmp, 0
	xor		edx, edx
	mov		edx, 8
	movd	MM2, edx
	psllq 	MM2, 4
	movd	edx, MM2
	mov	MMWORD PTR dwTmp, edx
	DisplayResults psllq, 0, 128, 0, dwTmp

	mov		MMWORD PTR dwTmp, 8
	movd	MM2, MMWORD PTR dwTmp
	psllq 	MM2, 4
	movd  	MMWORD PTR dwTmp, MM2
	DisplayResults psllq, 0, 128, 0, dwTmp

	mov		MMWORD PTR dwTmp, 0
	mov		ebx, 4
	mov		esi, 8
	movd	MMWORD PTR dwTmp[ebx+esi-12], MM2
	DisplayResults psllq, 0, 128, 0, dwTmp

	mov		MMWORD PTR dwTmp, 0
	mov		ebx, OFFSET dwTmp
	mov		esi, 8
	movd	[ebx+esi-8], MM2
	DisplayResults psllq, 0, 128, 0, dwTmp
ELSE
	mov		dwTmp, 0
	xor		edx, edx
	mov		edx, 8
	movd	MM2, dx
	psllq 	MM2, 4
	movd	dx, MM2
	mov		MMWORD PTR dwTmp, edx
	DisplayResults psllq, 0, 128, 0, dwTmp

	mov		dwTmp, 8
	movd	MM2, dwTmp
	psllq 	MM2, 4
	movd  	dwTmp, MM2
	DisplayResults psllq, 0, 128, 0, dwTmp

	mov		dwTmp, 0
	mov		bx, 4
	mov		si, 8
	movd	dwTmp[bx+si-12], MM2
	DisplayResults psllq, 0, 128, 0, dwTmp

	mov		dwTmp, 0
	mov		bx, OFFSET dwTmp
	mov		si, 8
	movd	[bx+si-8], MM2
	DisplayResults psllq, 0, 128, 0, dwTmp
	
ENDIF
	ret																			 
RunIAMMxTest1	EndP															 


;---------------------------------------------------------
; RunLoopTest1()
;
; Description:
;	Executes the loop dwCount times.
;
; Parameters:
;	dwCount: number of iterations to do..
;	
;---------------------------------------------------------

RunLoopTest1	Proc C Public	dwCount:DWORD
	push	ecx
	mov		ecx, dwCount
Again:	
	emms
    dec     ecx
    jnz     Again
	
	pop		ecx
	ret
RunLoopTest1 	EndP

;---------------------------------------------------------
; RunLoopTest2()
;
; Description:
;	Executes the loop dwCount times.
;
; Parameters:
;	dwCount: number of iterations to do..
;	
;---------------------------------------------------------

RunLoopTest2	Proc C Public	dwCount:DWORD
	push	ecx
	mov		ecx, dwCount
Again:	
	movq	MM1, qwTmp2
	pmaddwd MM1, qwTmp1
    dec     ecx
    jnz     Again
	
	pop		ecx
	ret
RunLoopTest2 	EndP


AccessInvalidData Proc C Public
	push ebx
    mov ebx, 0fffffff0h
    movq    mm0, [ebx]

    mov ebx, 0fffffff0h
    db 26h				 ; es override
    movq    mm0, [ebx]

    mov ebx, 0fffffff0h
    db 2eh				 ; cs override
    movq    mm0, [ebx]

	pop 	ebx
	ret
AccessInvalidData EndP

AccessInvalidSegment Proc C Public
IFDEF APP_32BIT
	push	es
	push	ds
	mov		ax, 0
	mov		es, ax
	mov		ds, ax

    lea		ebx, qwTmp2
    movq    mm0, [ebx]

    db 26h				 ; es override
    movq    mm0, [ebx]

StackFault:
    mov     eax, ss
    lsl     ebx, eax        ; Stack Segment in Win95 (Win32?) 
    sub     ebx, 10         ; expands downward...
  
	db 36h
    movq    mm2, DWORD PTR [ebx] ; Stack Fault here!

	db 36h
	paddd	mm2, DWORD PTR [ebx] ; Stack Fault here!

	pop		ds
	pop		es
ENDIF
	ret
AccessInvalidSegment EndP

	END

