/*
*    INTEL CORPORATION PROPRIETARY INFORMATION 
*
*    This software is supplied under the terms of a license
*    agreement or nondisclosure agreement with Intel Corporation 
*    and may not be copied or disclosed except in accordance with 
*    the terms of that agreement.
*    Copyright (c) 1991,1992,1993  Intel Corporation. 
*
*/
#ifndef __MMX_H__
#define __MMX_H__

typedef unsigned char  MMXU8;
typedef unsigned short MMXU16;
typedef unsigned long  MMXU32;
typedef signed   char  MMXS8;
typedef signed   short MMXS16;
typedef signed   long  MMXS32;

typedef struct {
 union {
  MMXU32 d[2];
  MMXU16 w[4];
  MMXU8  b[8];
  MMXS32 ds[2];
  MMXS16 ws[4];
  MMXS8  bs[8];
 } v;
} MMX64;  /* type of 64 bit items */

  /* FILE: mmx.c */
void packsswb(MMX64 *dst, MMX64 *src);
void packssdw(MMX64 *dst, MMX64 *src);
void packuswb(MMX64 *dst, MMX64 *src);
void paddb(MMX64 *dst, MMX64 *src);
void paddw(MMX64 *dst, MMX64 *src);
void paddd(MMX64 *dst, MMX64 *src);
void paddsb(MMX64 *dst, MMX64 *src);
void paddsw(MMX64 *dst, MMX64 *src);
void paddusb(MMX64 *dst, MMX64 *src);
void paddusw(MMX64 *dst, MMX64 *src);
void pand(MMX64 *dst, MMX64 *src);
void pandn(MMX64 *dst, MMX64 *src);
void pcmpeqb(MMX64 *dst, MMX64 *src);
void pcmpeqw(MMX64 *dst, MMX64 *src);
void pcmpeqd(MMX64 *dst, MMX64 *src);
void pcmpgtb(MMX64 *dst, MMX64 *src);
void pcmpgtw(MMX64 *dst, MMX64 *src);
void pcmpgtd(MMX64 *dst, MMX64 *src);
void pmaddwd(MMX64 *dst, MMX64 *src);
void pmulhw(MMX64 *dst, MMX64 *src);
void pmullw(MMX64 *dst, MMX64 *src);
void por(MMX64 *dst, MMX64 *src);
void psllw(MMX64 *dst, MMX64 *src);
void pslld(MMX64 *dst, MMX64 *src);
void psllq(MMX64 *dst, MMX64 *src);
void psllw_imm8(MMX64 *dst, MMXU8 imm8);
void pslld_imm8(MMX64 *dst, MMXU8 imm8);
void psllq_imm8(MMX64 *dst, MMXU8 imm8);
void psraw(MMX64 *dst, MMX64 *src);
void psrad(MMX64 *dst, MMX64 *src);
void psraw_imm8(MMX64 *dst, MMXU8 imm8);
void psrad_imm8(MMX64 *dst, MMXU8 imm8);
void psrlw(MMX64 *dst, MMX64 *src);
void psrld(MMX64 *dst, MMX64 *src);
void psrlq(MMX64 *dst, MMX64 *src);
void psrlw_imm8(MMX64 *dst, MMXU8 imm8);
void psrld_imm8(MMX64 *dst, MMXU8 imm8);
void psrlq_imm8(MMX64 *dst, MMXU8 imm8);
void psubb(MMX64 *dst, MMX64 *src);
void psubw(MMX64 *dst, MMX64 *src);
void psubd(MMX64 *dst, MMX64 *src);
void psubsb(MMX64 *dst, MMX64 *src);
void psubsw(MMX64 *dst, MMX64 *src);
void psubusb(MMX64 *dst, MMX64 *src);
void psubusw(MMX64 *dst, MMX64 *src);
void punpcklbw(MMX64 *dst, MMX64 *src);
void punpcklwd(MMX64 *dst, MMX64 *src);
void punpckldq(MMX64 *dst, MMX64 *src);
void punpckhbw(MMX64 *dst, MMX64 *src);
void punpckhwd(MMX64 *dst, MMX64 *src);
void punpckhdq(MMX64 *dst, MMX64 *src);
void pxor(MMX64 *dst, MMX64 *src);

#endif /* __MMX_H__ */

