/*
*    INTEL CORPORATION PROPRIETARY INFORMATION 
*
*    This software is supplied under the terms of a license
*    agreement or nondisclosure agreement with Intel Corporation 
*    and may not be copied or disclosed except in accordance with 
*    the terms of that agreement.
*    Copyright (c) 1991,1992,1993  Intel Corporation. 
*
*/

#include <stdio.h>
#ifndef TRUE
  #define TRUE 1
  #define FALSE 0
#endif
#ifndef BOOL
  #define BOOL int
#endif

char lineBuf[256];
#ifdef WIN_APP
	extern void PrintToEditor(char *pszText, BOOL bNewLine);
#elif WIN_VXD
	// BUGBUG: mike - aug-10-94 put something here..
int sprintf(char *pszText, const char *format, ...)
{ 
	while (*format!=0) {
		*pszText=*format;	
		pszText++, format++;
	}

	return 0;
}

#else	// Unix
void PrintToEditor(char *pszText, BOOL bNewLine)
{ 
    fprintf(stderr, lineBuf);
    if (bNewLine) fprintf(stderr, "\n");
}
#endif

typedef unsigned long   U32;       /* type of 32 bit items */
typedef struct { U32 w[2]; } U64;  /* type of 64 bit items */
	volatile U64 t1,t2,t3;
	volatile U32 t,z;
#define T1(line,inst, vh2,vl2,vh1,vl1,rh2,rl2) \
	t1.w[0] = vl1; t1.w[1] = vh1; \
	t2.w[0] = vl2; t2.w[1] = vh2; \
	t3.w[0] = t3.w[1] = 0; \
	asm("	movq	MM1,DWORD PTR _t1\n	" #inst "	MM1,DWORD PTR _t2\n	movq	DWORD PTR _t3,MM1"); \
	if (t3.w[0] != rl2  || t3.w[1] != rh2 ) \
		sprintf(lineBuf, #inst " %d: FAIL: t3 = %x %x and should be %x,%x",line,t3.w[1],t3.w[0],rh2,rl2); \
	else \
		sprintf(lineBuf, #inst " %d: PASS: t3 = %x %x and should be %x,%x",line,t3.w[1],t3.w[0],rh2,rl2); \
	PrintToEditor(lineBuf, TRUE);

#define T2(line,inst, vh,vl,r) \
	t1.w[0] = vl; t1.w[1] = vh; \
	t = 0; \
	asm("	movq	MM1,DWORD PTR _t1\n	" #inst "	MM1,DWORD PTR _t"); \
	if (t != r ) \
		sprintf(lineBuf, #inst " %d: FAIL: t = %x  and should be %x",line,t,r); \
	else \
		sprintf(lineBuf, #inst " %d: PASS: t = %x and should be %x",line,t,r);  \
	PrintToEditor(lineBuf, TRUE);
	
#define T3(line,inst, vh1,vl1,shift_cnt,rh2,rl2) \
	t1.w[0] = vl1; t1.w[1] = vh1; \
	t2.w[0] = shift_cnt; t2.w[1] = 0; \
	t3.w[0] = t3.w[1] = 0; \
	asm("	movq	MM1,DWORD PTR _t1\n	" #inst "	MM1,DWORD PTR _t2\n	movq	DWORD PTR _t3,MM1"); \
	if (t3.w[0] != rl2  || t3.w[1] != rh2 ) \
		sprintf(lineBuf, #inst " %d: FAIL: t3 = %x %x and should be %x,%x",line,t3.w[1],t3.w[0],rh2,rl2); \
	else \
		sprintf(lineBuf, #inst " %d: PASS: t3 = %x %x and should be %x,%x",line,t3.w[1],t3.w[0],rh2,rl2);  \
	PrintToEditor(lineBuf, TRUE);\
	asm("	movq	MM1,DWORD PTR _t1\n	" #inst "	MM1,"#shift_cnt "\n	movq	DWORD PTR _t3,MM1"); \
	if (t3.w[0] != rl2  || t3.w[1] != rh2 ) \
		sprintf(lineBuf, #inst " %d: FAIL: t3 = %x %x and should be %x,%x",line,t3.w[1],t3.w[0],rh2,rl2); \
	else \
		sprintf(lineBuf, #inst " %d: PASS: t3 = %x %x and should be %x,%x",line,t3.w[1],t3.w[0],rh2,rl2); \
	PrintToEditor(lineBuf, TRUE);
#define T4(line,inst, vh1,vl1,shift_cnt,rh2,rl2) \
	t1.w[0] = vl1; t1.w[1] = vh1; \
	t2.w[0] = shift_cnt; t2.w[1] = 0; \
	t3.w[0] = t3.w[1] = 0; \
	asm("	movq	MM1,DWORD PTR _t1\n	" #inst "	MM1,"#shift_cnt "\n	movq	DWORD PTR _t3,MM1"); \
	if (t3.w[0] != rl2  || t3.w[1] != rh2 ) \
		sprintf(lineBuf, #inst " %d: FAIL: t3 = %x %x and should be %x,%x",line,t3.w[1],t3.w[0],rh2,rl2); \
	else \
		sprintf(lineBuf, #inst " %d: PASS: t3 = %x %x and should be %x,%x",line,t3.w[1],t3.w[0],rh2,rl2); \
	PrintToEditor(lineBuf, TRUE);


testbase() {
#if (1)
asm("include iammx.inc");
/* addp, addup */
T1(__LINE__,paddb   ,0x807fb417,0xf3128575,0xff7f21a2,0xe5459173,0x7ffed5b9,0xd85716e8)
T1(__LINE__,paddsb  ,0x807fb417,0xf3128575,0xff7f21a2,0xe5459173,0x807fd5b9,0xd857807f)
T1(__LINE__,paddw   ,0x237a9a31,0xf3477f51,0x4ab0bc19,0x801e280e,0x6e2a564a,0x7365a75f)
T1(__LINE__,paddsw  ,0x237a9a31,0xf3477f51,0x4ab0bc19,0x801e280e,0x6e2a8000,0x80007fff)
T1(__LINE__,paddw   ,0x8000f301,0xf31e2301,0x134b7fff,0x6501b735,0x934b7300,0x581fda36)
T1(__LINE__,paddsw  ,0x8000f301,0xf31e2301,0x134b7fff,0x6501b735,0x934b7300,0x581fda36)
T1(__LINE__,paddusb ,0x128023d1,0xf1f33273,0xd17f1712,0x80b2d165,0xe3ff3ae3,0xffffffd8)
T1(__LINE__,paddusw ,0x80171749,0xf31583b1,0x831bac06,0x0e47751a,0xffffc34f,0xfffff8cb)
T1(__LINE__,paddd   ,0x237a9a31,0xf3477f51,0x4ab0bc19,0x801e280e,0x6e2b564a,0x7365a75f)
T1(__LINE__,paddd   ,0x8000f301,0xf31e2301,0x134b7fff,0x6501b735,0x934c7300,0x581fda36)
/* xcmp */
T1(__LINE__,pcmpeqb ,0x5585bc7f,0x3c5c8000,0x1257e580,0x3c99ff4a,0x00000000,0xff000000)
T1(__LINE__,pcmpgtb ,0x1257e580,0x3c99ff4a,0x5585bc7f,0x3c5c8000,0xff0000ff,0x00ff0000)
T1(__LINE__,pcmpeqw ,0x85bc4315,0x9413079a,0x12076719,0xab07079a,0x00000000,0x0000ffff)
T1(__LINE__,pcmpgtw ,0x12076719,0xab07079a,0x85bc4315,0x9413079a,0x00000000,0x00000000)
T1(__LINE__,pcmpeqd ,0x85bc4315,0x9413079a,0x12076719,0x9413079a,0x00000000,0xffffffff)
T1(__LINE__,pcmpgtd ,0x82076719,0x9b07079a,0x15bc4315,0x8413079a,0xffffffff,0x00000000)
/* xmul */
T1(__LINE__,pmulhw  ,0x8170217f,0x12340e08,0x00800080,0x00800080,0xffc00010,0x00090007)
T1(__LINE__,pmullw  ,0x3785bcd0,0x7faef351,0x9a3e8a43,0x45811274,0x74368a70,0x3caef2b4)
T1(__LINE__,pmaddwd  ,0x3785bcd0,0x71c771c7,0x9a3e8a43,0x80000400,0x08d4fea6,0xC8E39C00)
/* pack, unpack,  sigma */
T1(__LINE__,packsswb ,0x009a0037,0xfff5f372,0x8000831e,0x00ff1237,0x7f37f580,0x80807f7f)
T1(__LINE__,packuswb ,0x009a0037,0x0175f372,0x8000831e,0x00ff1237,0x9a37ff00,0x0000ffff)
T1(__LINE__,packssdw ,0x00000037,0x0175f372,0x8000831e,0x00ff1237,0x00377fff,0x80007fff)
T1(__LINE__,punpcklbw,0x00000000,0x11335577,0x00000000,0x22446688,0x11223344,0x55667788)
T1(__LINE__,punpcklwd,0x00000000,0x55556666,0x00000000,0xaaaabbbb,0x5555aaaa,0x6666bbbb)
T1(__LINE__,punpckldq,0x00000000,0x55556666,0x00000000,0xaaaabbbb,0x55556666,0xaaaabbbb)
T1(__LINE__,punpckhbw,0x11335577,0x00000000,0x22446688,0x00000000,0x11223344,0x55667788)
T1(__LINE__,punpckhwd,0x55556666,0x00000000,0xaaaabbbb,0x00000000,0x5555aaaa,0x6666bbbb)
T1(__LINE__,punpckhdq,0x55556666,0x00000000,0xaaaabbbb,0x00000000,0x55556666,0xaaaabbbb)
/* xshifts */
T3(__LINE__,psraw,0xff00aa55,0xaa095574,0,0xff00aa55,0xaa095574)

T3(__LINE__,psraw,0xff00aa55,0xaa095574,1,0xff80d52a,0xd5042aba)
T3(__LINE__,psraw,0xff00aa55,0xaa095574,9,0xffffffd5,0xffd5002a)
T3(__LINE__,psraw,0xff00aa55,0xaa095574,15,0xffffffff,0xffff0000)
T3(__LINE__,psraw,0xff00aa55,0xaa095574,16,0xffffffff,0xffff0000)
T3(__LINE__,psraw,0xff00aa55,0xaa095574,37,0xffffffff,0xffff0000)
T3(__LINE__,psllw,0x19ffb500,0x09aa7455,0,0x19ffb500,0x09aa7455)
T3(__LINE__,psllw,0x19ffb500,0x09aa7455,1,0x33fe6a00,0x1354e8aa)
T3(__LINE__,psllw,0x19ffb500,0x09aa7455,9,0xfe000000,0x5400aa00)
T3(__LINE__,psllw,0x19ffb500,0x09aa7455,15,0x80000000,0x00008000)
T3(__LINE__,psllw,0x19ffb500,0x09aa7455,16,0x00000000,0x00000000)
T3(__LINE__,psllw,0x19ffb500,0x09aa7455,37,0x00000000,0x00000000)
T3(__LINE__,psrlw,0xff00aa55,0xaa095574,0,0xff00aa55,0xaa095574)
T3(__LINE__,psrlw,0xff00aa55,0xaa095574,1,0x7f80552a,0x55042aba)
T3(__LINE__,psrlw,0xff00aa55,0xaa095574,9,0x007f0055,0x0055002a)
T3(__LINE__,psrlw,0xff00aa55,0xaa095574,15,0x00010001,0x00010000)
T3(__LINE__,psrlw,0xff00aa55,0xaa095574,16,0x00000000,0x00000000)
T3(__LINE__,psrlw,0xff00aa55,0xaa095574,37,0x00000000,0x00000000)
T3(__LINE__,psrad,0xff00aa55,0xaa095574,0,0xff00aa55,0xaa095574)
T3(__LINE__,psrad,0xff00aa55,0xaa095574,1,0xff80552a,0xd504aaba)
T3(__LINE__,psrad,0xff00aa55,0xaa095574,9,0xffff8055,0xffd504aa)
T3(__LINE__,psrad,0xff00aa55,0xaa095574,15,0xfffffe01,0xffff5412)
T3(__LINE__,psrad,0xff00aa55,0xaa095574,16,0xffffff00,0xffffaa09)
T3(__LINE__,psrad,0xff00aa55,0x0a095574,37,0xffffffff,0x00000000)
T3(__LINE__,pslld,0x19ffb500,0x09aa7455,0,0x19ffb500,0x09aa7455)
T3(__LINE__,pslld,0x19ffb500,0x09aa7455,1,0x33ff6a00,0x1354e8aa)
T3(__LINE__,pslld,0x19ffb500,0x09aa7455,9,0xff6a0000,0x54e8aa00)
T3(__LINE__,pslld,0x19ffb500,0x09aa7455,15,0xda800000,0x3a2a8000)
T3(__LINE__,pslld,0x19ffb500,0x09aa7455,16,0xb5000000,0x74550000)
T3(__LINE__,pslld,0x19ffb500,0x09aa7455,37,0x00000000,0x00000000)
T3(__LINE__,psrld,0xff00aa55,0xaa095574,0,0xff00aa55,0xaa095574)
T3(__LINE__,psrld,0xff00aa55,0xaa095574,1,0x7f80552a,0x5504aaba)
T3(__LINE__,psrld,0xff00aa55,0xaa095574,9,0x007f8055,0x005504aa)
T3(__LINE__,psrld,0xff00aa55,0xaa095574,15,0x001fe01,0x00015412)
T3(__LINE__,psrld,0xff00aa55,0xaa095574,16,0x0000ff00,0x0000aa09)
T3(__LINE__,psrld,0xff00aa55,0xaa095574,37,0x00000000,0x00000000)


/* subrp, subrup */
T1(__LINE__,psubsb  ,0xefe54e3f,0xe1478219,0xc7f73472,0x12f37181,0xd812e633,0x31ac7f80)
T1(__LINE__,psubb   ,0xefe54e3f,0xe1478219,0xc7f73472,0x12f37181,0xd812e633,0x31acef68)
T1(__LINE__,psubsw  ,0xe1804756,0x82c1197e,0x123af307,0x713b813a,0x30baabb1,0x7fff8000)
T1(__LINE__,psubw   ,0xe1804756,0x82c1197e,0x123af307,0x713b813a,0x30baabb1,0xee7a67bc)
T1(__LINE__,psubd   ,0xe1804756,0x82c1197e,0x123af307,0x713b813a,0x30baabb1,0xee7a67bc)
T1(__LINE__,psubsw  ,0xef39e510,0x4ea63f07,0xc72af714,0x340f72bc,0xd7f11204,0xe56933b5)
T1(__LINE__,psubw   ,0xef39e510,0x4ea63f07,0xc72af714,0x340f72bc,0xd7f11204,0xe56933b5)
T1(__LINE__,psubusb ,0xefe54e3f,0xe1478219,0xc7f73472,0x12f37181,0x00120033,0x00ac0068)
T1(__LINE__,psubusw ,0xe1804756,0x82c1197e,0x123af307,0x713b813a,0x0000abb1,0x000067bc)
T1(__LINE__,psubusw ,0xef39e510,0x4ea63f07,0xc72af714,0x340f72bc,0x00001204,0x000033b5)
T1(__LINE__,por     ,0xc72af714,0x340f72bc,0xef39e510,0x4ea63f07,0xef3bf714,0x7eaf7fbf)
T1(__LINE__,por     ,0x01020304,0x05060708,0x10203040,0x50607080,0x11223344,0x55667788)
T1(__LINE__,pand    ,0x01020304,0x05060708,0x10203040,0x50607080,0x00000000,0x00000000)
T1(__LINE__,pand    ,0x01020304,0x05060708,0x11223344,0x50607080,0x01020304,0x00000000)
T1(__LINE__,pandn   ,0xfefdfcfb,0xfaf9f8f7,0x10203040,0x50607080,0xeeddccbb,0xaa998877)
T1(__LINE__,pandn   ,0xfefdfcfb,0xfaf9f8f7,0x11223344,0x50607080,0xeeddccbb,0xaa998877)
T3(__LINE__,psllq    ,0xfefdfcfb,0xfaf9f8f7,4,0xefdfcfbf,0xaf9f8f70)
T3(__LINE__,psrlq    ,0xefdfcfbf,0xaf9f8f70,4,0x0efdfcfb,0xfaf9f8f7)


t = 0;
asm("	PUSH EDX\n	MOV	EDX,8\n	movdt	MM2,EDX\n	psllq MM2,4\n");
asm("	movdf  EDX,MM2\n	MOV DWORD PTR _t,EDX\n	POP EDX");
if (t == 128 ) 
	sprintf(lineBuf, " PASS: t = %d and should be 128",t);
else
	sprintf(lineBuf, " FAIL: t = %d and should be 128",t);
PrintToEditor(lineBuf, TRUE);

t = 8;
asm("movdt	MM2,DWORD PTR _t\n	psllq MM2,4\n	movdf  DWORD PTR _t,MM2");
if (t == 128 ) 
	sprintf(lineBuf, " PASS: t = %d and should be 128",t);
else
	sprintf(lineBuf, " FAIL: t = %d and should be 128",t);
PrintToEditor(lineBuf, TRUE);

t = 0;
asm("	MOV	EAX,4\n	MOV	ECX,8\n	movdf	DWORD PTR _t[EAX+ECX*4-36],MM2\n");
if (t == 128 ) 
	sprintf(lineBuf, " PASS: t = %d and should be 128",t);
else
	sprintf(lineBuf, " FAIL: t = %d and should be 128",t);
PrintToEditor(lineBuf, TRUE);

t = 0;
asm("	MOV	EAX, OFFSET FLAT: _t\n	MOV	ECX,8\n	movdf	DWORD PTR [EAX+ECX*4-32],MM2\n");
if (t == 128 ) 
	sprintf(lineBuf, " PASS: t = %d and should be 128",t);
else
	sprintf(lineBuf, " FAIL: t = %d and should be 128",t);
PrintToEditor(lineBuf, TRUE);


asm ("emms \n");
sprintf(lineBuf, " EMMS");
PrintToEditor(lineBuf, TRUE);

#endif
}

void CompareTandZ ()
{
	if (t == z)
		sprintf(lineBuf, " AddressSizeOverRide PASS: t = %d and t1 = %d",t, z);
	else
		sprintf(lineBuf, " AddressSizeOverRide FAIL: t = %d and t1 = %d",t, z);
	PrintToEditor(lineBuf, TRUE);
}

real_main()
{	
	testbase();

}
